/*****************************************************
Date    : 15.01.2013
Author  : ----------
Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
#include <stdio.h>
#include <spi.h>

#define KEY1          PIND.5  //  1
#define KEY2          PIND.6  //  2
#define KEY3          PIND.7  //  3


eeprom unsigned int data1 = 0;  //   
eeprom unsigned long int data6 = 0;//   
eeprom unsigned long int data2 = 258;//  
eeprom unsigned int  eepromPrFors=63900; //   (  ,    0,01)/1000
eeprom unsigned int  eepromvolt=122; //  
eeprom unsigned int  eepromDS=675; //    100 
//eeprom unsigned int  fon=0; //  
eeprom unsigned int eeim1 = 0;
eeprom unsigned char eeMOD = 2;

unsigned char rx=0,r=0,tsP=0,xP=0,MOD=2;;
unsigned char ts=0,tm=0,x=0,y=0,z=0,trx=0;
unsigned int speed=0,mrr=0,speedP=0;;
unsigned int  ds=0, dsl=0,n1=0,bgcolor=0;
bit park=0;
unsigned int  PrFors=0;
unsigned long int  voltag=0;
unsigned long int dat1=0,dat2=0,dat3=0,dat6=0,volt=0;
unsigned int im1= 0 ;
unsigned long int resu= 0;
volatile bit first_draw=1;
volatile unsigned int n;


#include "C1-01_SPIR182.c"
char convert[32];

///menu
#define ROB          1
#define FORS         2
#define voltmode     3
#define PROBEG       4
#define DS           5
#define SP           6
#define a         7
#define b         8
#define c         9
#define d         10
#define e           11
#define f           12
int mode;

// External Interrupt 1 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
ts++;
im1 = im1+1;
if (im1>=ds)
 {
 im1=0;
 dat1=dat1+1;
 dat6=dat6+1;
 };}

// External Interrupt 0 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{
tsP++;
if(PIND.3) TCCR1B=0x02;
else TCCR1B=0x00;
}

void out(void)
{
// 
z++;
if(z==20) {z=0; rx=trx; trx=0;};

if(speed>200)speed = 0;
if(speed>9) park=0;
else park=1;
//if(speed>0) park=0;
//else park=1;
mrr=(float)rx/(float)speed*100; //   /100
x++;
//  x = (a + b / 2) / b      (7740+600/2)/600      13,4
//dsl=13200/ds;
dsl=(7740+ds/2)/ds;
if(x==dsl) {x=0; speed=ts; ts=0;};
if(speedP == 0)TCCR1B=0x00;
xP++;
if(xP==10) {xP=0; speedP=tsP; tsP=0;};
 }

 // Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
n++;
if(n==360) {n=0; out();};
}

// Timer 1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
TCNT1=PrFors; //64744;;//fcf8 //fors
r++;
tm++;
y++;
if(y==3)
{
trx++;
y=0;
};
dat2++;
}


#define ADC_VREF_TYPE 0x20

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
//delay_us(10);
ADCSRA|=0x40;
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}



void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In
// State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=T
PORTB=0x00;
DDRB=0x3E;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out
// State6=T State5=T State4=T State3=T State2=T State1=T State0=1
PORTC=0x01;
DDRC=0x01;


// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=P State6=P State5=P State4=T State3=T State2=P State1=T State0=T
PORTD=0xE4;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,0 kHz
TCCR0=0x02;
TCNT0=0;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000,0 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;

TCNT1H=0xFC;
TCNT1L=0xD0;

ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 11059,200 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Any change
// INT1: On
// INT1 Mode: Any change
//GICR|=0xC0;
//MCUCR=0x0D;
//GIFR=0xC0;

GICR|=0xC0;
MCUCR=0x07;//06
GIFR=0xC0;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x05;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 691,200 kHz
// ADC Voltage Reference: AREF pin
// Only the 8 most significant bits of
// the AD conversion result are used
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x84;

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 2*4000,000 kHz
// SPI Clock Phase: Cycle Start
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x50;
SPSR=0x01;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Global enable interrupts
#asm("sei")
bgcolor=0x0000;
lcd_init_rgb();
delay_ms(500);
dat1=data1;
dat6=data6;
dat2=data2;
PrFors=eepromPrFors;
voltag=eepromvolt;
ds=eepromDS;
im1=eeim1;
MOD=eeMOD;
mode = ROB;
while (1)
      {

if (read_adc(1)<50)
{
if (dat1!=data1) data1=dat1;
if (dat2!=data2) data2=dat2;
if (dat6!=data6) data6=dat6;
if (im1!=eeim1) eeim1=im1;
delay_ms(1000);
PORTC.0=0;
};
//--//
if (dat1 > 9999){ dat1 = 0;}        // 
if (dat6 > 9999999){ dat6 = 0;}     // 
dat3=(dat2/1000)/MOD;                    //  

volt=read_adc(1);
volt=((volt*1000)*(voltag+600))/1000000;

///========================================================
  switch (mode) {                                  //   
  case ROB:

  if (first_draw == 1) {                       //     ,    
  lcd_line(0,21,60,21,brown);
  lcd_line(0,20,60,20,brown);
  lcd_line(0,55,160,55,brown);
  lcd_line(0,56,160,56,brown);
  lcd_line(0,110,160,110,brown);
  lcd_line(0,111,160,111,brown);
  lcd_line(100,79,160,79,brown);
  lcd_line(100,80,160,80,brown);
  lcd_line(80,20,80,55,brown);
  lcd_line(81,20,81,55,brown);
  lcd_line(55,21,80,21,brown);
  lcd_line(55,20,80,20,brown);
  put_string(3,6,"",RED,1);
  put_string(100,60,"",RED,1);
  put_string(55,23,"",WHITE,1);
  put_string(55,37,"/",WHITE,1);
  first_draw = 0;};

 //
 sprintf(convert,"%d%d.%d",(volt/100)%10,(volt/10)%10,volt%10);
 put_string(115,60,convert,WHITE,1);
 sprintf(convert,"%d%d%d",(speed/100)%10,(speed/10)%10,speed%10);
 put_string(3,25,convert,YELLOW,2); //24,30
 // 
 sprintf(convert,"%d%d.%d%d.",(dat3/1000)%10,(dat3/100)%10,(dat3/10)%10,dat3%10);
 put_string(85,33,convert,WHITE,1);

if (dat1<=9) //  
 {resu=0;}
 else {
 resu=((dat3*100)/dat1)*100;
 }

sprintf(convert,"%d%d.%d/100",(resu/10000)%10,(resu/1000)%10,(resu/100)%10,(resu/100)%10);
put_string(85,6,convert,WHITE,1);

 //////////
    if(!park)
    {
     sprintf(convert,"%d%d.%d",(mrr/100)%10,(mrr/10)%10,mrr%10);
     put_string(3,65,convert,YELLOW,3);
     put_string(105,87,"/100",WHITE,1);

     }
    else    //XX
    {
     sprintf(convert,"%d%d.%d",(rx/100)%10,(rx/10)%10,rx%10);
     put_string(3,65,convert,YELLOW,3);
     put_string(105,87,"/",WHITE,1);

     };

  // 
   sprintf(convert,"%d%d%d.%d ",(dat1/1000)%10,(dat1/100)%10,(dat1/10)%10,dat1%10);
   put_string(3,115,convert,WHITE,1);


   sprintf(convert,"%d%d%d%d%d%d ",(dat6/1000000)%10,(dat6/100000)%10,(dat6/10000)%10,(dat6/1000)%10,(dat6/100)%10,(dat6/10)%10);
   put_string(85,115,convert,WHITE,1);// }

///////////////////////////////////////////////////////////////////////////////////
// 
if (KEY2==0){
dat1= 0;
dat2= 0;
dat3= 0;
resu=0;
im1=0;}
//=============================
 if (KEY3 == 0) {
            first_draw = 1;
            fill_screen(bgcolor);
            mode=a;
            }
//=============================
};
n1++;
if(n1>=250) {n1=0; }; //210
//=======================================  ======================
             switch (mode) {                               //   
             case a:
             put_string(10,35,"",YELLOW,1);
             if (KEY2 == 0) {mode=FORS;};
             if (KEY3 == 0) {delay_ms(250);mode=b;};
             };

             switch (mode) {                               //   
             case b:
             put_string(10,35,"",YELLOW,1);
             if (KEY2 == 0) {mode=voltmode;};
             if (KEY3 == 0) {delay_ms(250);mode=c;};
            };

             switch (mode) {                               //   
             case c:
             put_string(10,35,"",YELLOW,1);
             if (KEY2 == 0) {mode=PROBEG;};
             if (KEY3 == 0) {delay_ms(250);mode=d;};
             };

             switch (mode) {                               //   
             case d:
             put_string(10,35,"  ",YELLOW,1);
             if (KEY2 == 0) {mode=DS;};
             if (KEY3 == 0) {delay_ms(250);mode=e;};
             };

             switch (mode) {                               //   
             case e:
             put_string(10,35,"",YELLOW,1);
             if (KEY2 == 0) {mode=SP;};
             if (KEY3 == 0) {delay_ms(250);//mode=a;};
             first_draw = 1;
             fill_screen(bgcolor);
             mode=ROB;};
             };


switch (mode) {                               //   
case FORS:
sprintf(convert,"%d%d%d%d%d",(PrFors/10000)%10,(PrFors/1000)%10,(PrFors/100)%10,(PrFors/10)%10,PrFors%10);
put_string(60,35,convert,WHITE,1);
sprintf(convert,"%d%d.%d",(rx/100)%10,(rx/10)%10,rx%10);
put_string(110,35,convert,GREEN,1);
if (PrFors > 65535){ PrFors = 0;}
if ( KEY2==0){delay_ms(50);
PrFors=PrFors+1;
n1=0;
}
if ( KEY3==0){delay_ms(50);
PrFors=PrFors-1;
n1=0;
}
if (n1>240)
{if (PrFors!=eepromPrFors) eepromPrFors=PrFors;fill_screen(bgcolor);
mode=a;}
};


// =====================================
 switch (mode) {                                  //   
 case voltmode:

           sprintf(convert,"%d%d%d",(voltag/100)%10,(voltag/10)%10,voltag%10);
           put_string(60,35,convert,WHITE,1);
           sprintf(convert,"%d%d.%d",(volt/100)%10,(volt/10)%10,volt%10);
           put_string(110,35,convert,GREEN,1);
              if (voltag>=200) {voltag=0;}
              if(KEY2==0){ delay_ms(150);
              voltag=voltag+1; //    
              n1=0;
              }
              if(KEY3==0){ delay_ms(150);
              voltag=voltag-1; //    
              n1=0;
              }
 //=============================
              if (n1>240)
              {
              if (voltag!=eepromvolt)eepromvolt=voltag;
              fill_screen(bgcolor);
              mode=b;
              }};
//=======================================
           switch (mode) {                                  //   
           case PROBEG:
           sprintf(convert,"%d%d%d%d%d%d",(dat6/1000000)%10,(dat6/100000)%10,(dat6/10000)%10,(dat6/1000)%10,(dat6/100)%10,(dat6/10)%10);
           put_string(60,35,convert,WHITE,1);

           if(KEY2==0)  //    
           {
               dat6=dat6+10; //     
           n1=0;
           }

           if(KEY3==0)   //    
           {
           dat6=dat6-10; //     
           n1=0;
           }
            //=============================
          if (n1>240) {
          if (dat6!=data6) data6=dat6;
          fill_screen(bgcolor);
          mode=c;}
//=============================
};

// =====================================
 switch (mode) {                                  //   
case DS:

        sprintf(convert,"%d%d%d%d",(ds/1000)%10,(ds/100)%10,(ds/10)%10,ds%10);
        put_string(60,35,convert,WHITE,1);

        if (ds > 3000){ ds = 0;}
       // if (ds < 100){ ds = 100;}
        if(KEY2==0)  //    
        {
        delay_ms(150);
        ds = ds + 1;n1=0;}
        if(KEY3==0)   //    
        {delay_ms(150);ds=ds-1;n1=0;}
        //=============================
        if (n1>240) {
        if (ds!=eepromDS) eepromDS=ds;
        fill_screen(bgcolor);
        mode=d;}
        }

         //=======================================
 switch (mode) {                                  //      !!!
case SP:
            if (MOD == 2)  put_string(80,35,"",WHITE,1);
           if (MOD == 1)  put_string(80,35,"   ",WHITE,1);
           if (KEY2==0)  //    
            {
            MOD=MOD+1;
            n1=0;
            if (MOD > 2){ MOD = 1;};
            eeMOD = MOD;
            while (KEY2==0)delay_ms(30);};
            //=============================
           if (n1>240) {
           fill_screen(bgcolor);
           mode=e;}
           };
//====================================================================
}}

