
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _rx=R5
	.DEF _r=R4
	.DEF _tsP=R7
	.DEF _xP=R6
	.DEF _MOD=R9
	.DEF _ts=R8
	.DEF _tm=R11
	.DEF _x=R10
	.DEF _y=R13
	.DEF _z=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_ascii_tab_G000:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xFE,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x30,0x30
	.DB  0x0,0x0,0x2,0x6,0xC,0x18,0x30,0x60
	.DB  0xC0,0x80,0x0,0x0,0x0,0x7C,0xC6,0xCE
	.DB  0xDE,0xF6,0xE6,0xC6,0xC6,0x7C,0x0,0x0
	.DB  0x18,0x38,0x78,0x18,0x18,0x18,0x18,0x18
	.DB  0x7E,0x0,0x0,0x7C,0xC6,0x6,0xC,0x18
	.DB  0x30,0x60,0xC6,0xFE,0x0,0x0,0x7C,0xC6
	.DB  0x6,0x6,0x3C,0x6,0x6,0xC6,0x7C,0x0
	.DB  0x0,0xC,0x1C,0x3C,0x6C,0xCC,0xFE,0xC
	.DB  0xC,0x1E,0x0,0x0,0xFE,0xC0,0xC0,0xC0
	.DB  0xFC,0x6,0x6,0xC6,0x7C,0x0,0x0,0x38
	.DB  0x60,0xC0,0xC0,0xFC,0xC6,0xC6,0xC6,0x7C
	.DB  0x0,0x0,0xFE,0xC6,0x6,0xC,0x18,0x30
	.DB  0x30,0x30,0x30,0x0,0x0,0x7C,0xC6,0xC6
	.DB  0xC6,0x7C,0xC6,0xC6,0xC6,0x7C,0x0,0x0
	.DB  0x7C,0xC6,0xC6,0xC6,0x7E,0x6,0x6,0xC
	.DB  0x78,0x0,0x0,0x0,0x18,0x18,0x0,0x0
	.DB  0x0,0x18,0x18,0x0,0x0,0x38,0x6C,0x6C
	.DB  0x38,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1E,0x36,0x66,0xC6,0xC6,0xFE,0xC6
	.DB  0xC6,0xC6,0x0,0x0,0xFE,0x62,0x60,0x7C
	.DB  0x66,0x66,0x66,0x66,0xFC,0x0,0x0,0xFC
	.DB  0x66,0x66,0x66,0x7C,0x66,0x66,0x66,0xFC
	.DB  0x0,0x0,0xFE,0x62,0x62,0x60,0x60,0x60
	.DB  0x60,0x60,0xF0,0x0,0x0,0x1E,0x36,0x66
	.DB  0x66,0x66,0x66,0x66,0x66,0xFF,0xC3,0x0
	.DB  0xFE,0x66,0x62,0x68,0x78,0x68,0x62,0x66
	.DB  0xFE,0x0,0x0,0xD6,0xD6,0x54,0x54,0x7C
	.DB  0x54,0xD6,0xD6,0xD6,0x0,0x0,0x7C,0xC6
	.DB  0x6,0x6,0x3C,0x6,0x6,0xC6,0x7C,0x0
	.DB  0x0,0xC6,0xC6,0xCE,0xDE,0xF6,0xE6,0xC6
	.DB  0xC6,0xC6,0x0,0x38,0xC6,0xC6,0xCE,0xDE
	.DB  0xF6,0xE6,0xC6,0xC6,0xC6,0x0,0x0,0xE6
	.DB  0x66,0x6C,0x6C,0x78,0x6C,0x6C,0x66,0xE6
	.DB  0x0,0x0,0x1E,0x36,0x66,0xC6,0xC6,0xC6
	.DB  0xC6,0xC6,0xC6,0x0,0x0,0xC6,0xEE,0xFE
	.DB  0xFE,0xD6,0xC6,0xC6,0xC6,0xC6,0x0,0x0
	.DB  0xC6,0xC6,0xC6,0xC6,0xFE,0xC6,0xC6,0xC6
	.DB  0xC6,0x0,0x0,0x7C,0xC6,0xC6,0xC6,0xC6
	.DB  0xC6,0xC6,0xC6,0x7C,0x0,0x0,0xFE,0xC6
	.DB  0xC6,0xC6,0xC6,0xC6,0xC6,0xC6,0xC6,0x0
	.DB  0x0,0xFC,0x66,0x66,0x66,0x7C,0x60,0x60
	.DB  0x60,0xF0,0x0,0x0,0x3C,0x66,0xC2,0xC0
	.DB  0xC0,0xC0,0xC2,0x66,0x3C,0x0,0x0,0x7E
	.DB  0x5A,0x18,0x18,0x18,0x18,0x18,0x18,0x3C
	.DB  0x0,0x0,0xC6,0xC6,0xC6,0xC6,0xC6,0x7E
	.DB  0x6,0xC6,0x7C,0x0,0x3C,0x18,0x7E,0xDB
	.DB  0xDB,0xDB,0xDB,0x7E,0x18,0x3C,0x0,0x0
	.DB  0xC6,0xC6,0x6C,0x7C,0x38,0x7C,0x6C,0xC6
	.DB  0xC6,0x0,0x0,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0xCC,0xCC,0xCC,0xFE,0x6,0x0,0xC6,0xC6
	.DB  0xC6,0xC6,0xC6,0x7E,0x6,0x6,0x6,0x0
	.DB  0x0,0xDB,0xDB,0xDB,0xDB,0xDB,0xDB,0xDB
	.DB  0xDB,0xFF,0x0,0x0,0xDB,0xDB,0xDB,0xDB
	.DB  0xDB,0xDB,0xDB,0xDB,0xFF,0x3,0x0,0x0
	.DB  0x0,0x0,0x7E,0x0,0x0,0x7E,0x0,0x0
	.DB  0x0,0x0,0xC3,0xC3,0xC3,0xF3,0xDB,0xDB
	.DB  0xDB,0xDB,0xF3,0x0,0x0,0xF0,0x60,0x60
	.DB  0x7C,0x66,0x66,0x66,0x66,0xFC,0x0,0x0
	.DB  0x7C,0xC6,0x6,0x26,0x3E,0x26,0x6,0xC6
	.DB  0x7C,0x0,0x0,0xCE,0xDB,0xDB,0xDB,0xFB
	.DB  0xDB,0xDB,0xDB,0xCE,0x0,0x0,0x3F,0x66
	.DB  0x66,0x66,0x3E,0x3E,0x66,0x66,0xE7,0x0
	.DB  0x0,0x0,0x0,0x0,0x78,0xC,0x7C,0xCC
	.DB  0xCC,0x76,0x0,0x2,0x6,0x3C,0x60,0x60
	.DB  0x7C,0x66,0x66,0x66,0x3C,0x0,0x0,0x0
	.DB  0x0,0x0,0xFC,0x66,0x7C,0x66,0x66,0xFC
	.DB  0x0,0x0,0x0,0x0,0x0,0x7E,0x32,0x30
	.DB  0x30,0x30,0x78,0x0,0x0,0x0,0x0,0x0
	.DB  0x1E,0x36,0x36,0x66,0x66,0xFF,0xC3,0x0
	.DB  0x0,0x0,0x0,0x7C,0xC6,0xFE,0xC0,0xC6
	.DB  0x7C,0x0,0x0,0x0,0x0,0x0,0xD6,0xD6
	.DB  0x7C,0x54,0xD6,0xD6,0x0,0x0,0x0,0x0
	.DB  0x0,0x3C,0x66,0xC,0x6,0x66,0x3C,0x0
	.DB  0x0,0x0,0x0,0x0,0xC6,0xCE,0xD6,0xE6
	.DB  0xC6,0xC6,0x0,0x0,0x0,0x38,0x38,0xC6
	.DB  0xCE,0xD6,0xE6,0xC6,0xC6,0x0,0x0,0x0
	.DB  0x0,0x0,0xE6,0x6C,0x78,0x78,0x6C,0xE6
	.DB  0x0,0x0,0x0,0x0,0x0,0x1E,0x36,0x66
	.DB  0x66,0x66,0x66,0x0,0x0,0x0,0x0,0x0
	.DB  0xC6,0xEE,0xFE,0xD6,0xD6,0xC6,0x0,0x0
	.DB  0x0,0x0,0x0,0xC6,0xC6,0xFE,0xC6,0xC6
	.DB  0xC6,0x0,0x0,0x0,0x0,0x0,0x7C,0xC6
	.DB  0xC6,0xC6,0xC6,0x7C,0x0,0x0,0x0,0x0
	.DB  0x0,0xFE,0xC6,0xC6,0xC6,0xC6,0xC6,0x0
	.DB  0x0,0x0,0x0,0x0,0xDC,0x66,0x66,0x66
	.DB  0x66,0x7C,0x60,0x0,0x0,0x0,0x0,0x7C
	.DB  0xC6,0xC0,0xC0,0xC6,0x7C,0x0,0x0,0x0
	.DB  0x0,0x0,0x7E,0x5A,0x18,0x18,0x18,0x3C
	.DB  0x0,0x0,0x0,0x0,0x0,0xC6,0xC6,0xC6
	.DB  0xC6,0x7E,0x6,0xC6,0x0,0x0,0x0,0x3C
	.DB  0x18,0x7E,0xDB,0xDB,0xDB,0x7E,0x18,0x0
	.DB  0x0,0x0,0x0,0xC6,0x6C,0x38,0x38,0x6C
	.DB  0xC6,0x0,0x0,0x0,0x0,0x0,0xCC,0xCC
	.DB  0xCC,0xCC,0xCC,0xFE,0x6,0x0,0x0,0x0
	.DB  0x0,0xC6,0xC6,0xC6,0x7E,0x6,0x6,0x0
	.DB  0x0,0x0,0x0,0x0,0xD6,0xD6,0xD6,0xD6
	.DB  0xD6,0xFE,0x0,0x0,0x0,0x0,0x0,0xD6
	.DB  0xD6,0xD6,0xD6,0xD6,0xFE,0x3,0x0,0x60
	.DB  0x30,0x18,0xC,0x6,0xC,0x18,0x30,0x60
	.DB  0x0,0x0,0x0,0x0,0x0,0xC6,0xC6,0xF6
	.DB  0xDE,0xDE,0xF6,0x0,0x0,0x0,0x0,0x0
	.DB  0xF0,0x60,0x7C,0x66,0x66,0xFC,0x0,0x0
	.DB  0xC6,0xC6,0xC6,0xC6,0xC6,0xC6,0xC6,0xC6
	.DB  0x7C,0x0,0x0,0x0,0x0,0x0,0xCE,0xDB
	.DB  0xFB,0xDB,0xDB,0xCE,0x0,0x0,0x0,0x0
	.DB  0x0,0x7E,0xCC,0x7C,0x6C,0xCC,0xCE,0x0
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0002

_0xCF:
	.DB  0x0,0x0,0x0,0x0,0x0,0x2,0x0,0x0
	.DB  0x0,0x0
_0x0:
	.DB  0xD1,0xF0,0xE5,0xE4,0xED,0xE8,0xE9,0x0
	.DB  0xFD,0xDA,0x0,0xEA,0xEC,0x0,0x2F,0xF7
	.DB  0x0,0x25,0x64,0x25,0x64,0x2E,0x25,0x64
	.DB  0xE2,0x0,0x25,0x64,0x25,0x64,0x25,0x64
	.DB  0x0,0x25,0x64,0x25,0x64,0x2E,0x25,0x64
	.DB  0x25,0x64,0xEB,0x2E,0xE1,0x0,0x25,0x64
	.DB  0x25,0x64,0x2E,0x25,0x64,0xEB,0x2F,0x31
	.DB  0x30,0x30,0x0,0x25,0x64,0x25,0x64,0x2E
	.DB  0x25,0x64,0x0,0xEB,0x2F,0xF7,0xE0,0xF1
	.DB  0x0,0x25,0x64,0x25,0x64,0x25,0x64,0x2E
	.DB  0x25,0x64,0x20,0xEA,0xEC,0x0,0x25,0x64
	.DB  0x25,0x64,0x25,0x64,0x25,0x64,0x25,0x64
	.DB  0x25,0x64,0x20,0xEA,0xEC,0x0,0xD4,0xEE
	.DB  0xF0,0xF1,0x0,0xC2,0xEE,0xEB,0xF2,0x0
	.DB  0xCF,0xF3,0xF2,0xFC,0x0,0xC4,0xD1,0x20
	.DB  0x20,0x0,0xD2,0xCE,0xCF,0xCB,0xC8,0xC2
	.DB  0xCE,0x0,0x25,0x64,0x25,0x64,0x25,0x64
	.DB  0x25,0x64,0x25,0x64,0x0,0x25,0x64,0x25
	.DB  0x64,0x25,0x64,0x25,0x64,0x25,0x64,0x25
	.DB  0x64,0x0,0xE4,0xE5,0xEB,0xE8,0xF2,0xE5
	.DB  0xEB,0xFC,0x0,0xED,0xEE,0xF0,0xEC,0xE0
	.DB  0x20,0x20,0x20,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x08
	.DW  _0x79
	.DW  _0x0*2

	.DW  0x03
	.DW  _0x79+8
	.DW  _0x0*2+8

	.DW  0x03
	.DW  _0x79+11
	.DW  _0x0*2+11

	.DW  0x03
	.DW  _0x79+14
	.DW  _0x0*2+14

	.DW  0x06
	.DW  _0x79+17
	.DW  _0x0*2+53

	.DW  0x06
	.DW  _0x79+23
	.DW  _0x0*2+67

	.DW  0x05
	.DW  _0x79+29
	.DW  _0x0*2+102

	.DW  0x05
	.DW  _0x79+34
	.DW  _0x0*2+107

	.DW  0x05
	.DW  _0x79+39
	.DW  _0x0*2+112

	.DW  0x05
	.DW  _0x79+44
	.DW  _0x0*2+117

	.DW  0x08
	.DW  _0x79+49
	.DW  _0x0*2+122

	.DW  0x09
	.DW  _0x79+57
	.DW  _0x0*2+154

	.DW  0x09
	.DW  _0x79+66
	.DW  _0x0*2+163

	.DW  0x0A
	.DW  0x04
	.DW  _0xCF*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;Date    : 15.01.2013
;Author  : ----------
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;#include <spi.h>
;
;#define KEY1          PIND.5  //  1
;#define KEY2          PIND.6  //  2
;#define KEY3          PIND.7  //  3
;
;
;eeprom unsigned int data1 = 0;  //   
;eeprom unsigned long int data6 = 0;//   
;eeprom unsigned long int data2 = 258;//  
;eeprom unsigned int  eepromPrFors=63900; //   (  ,    0,01)/1000
;eeprom unsigned int  eepromvolt=122; //  
;eeprom unsigned int  eepromDS=675; //    100 
;//eeprom unsigned int  fon=0; //  
;eeprom unsigned int eeim1 = 0;
;eeprom unsigned char eeMOD = 2;
;
;unsigned char rx=0,r=0,tsP=0,xP=0,MOD=2;;
;unsigned char ts=0,tm=0,x=0,y=0,z=0,trx=0;
;unsigned int speed=0,mrr=0,speedP=0;;
;unsigned int  ds=0, dsl=0,n1=0,bgcolor=0;
;bit park=0;
;unsigned int  PrFors=0;
;unsigned long int  voltag=0;
;unsigned long int dat1=0,dat2=0,dat3=0,dat6=0,volt=0;
;unsigned int im1= 0 ;
;unsigned long int resu= 0;
;volatile bit first_draw=1;
;volatile unsigned int n;
;
;
;#include "C1-01_SPIR182.c"
;
;
;#include <mega8.h>
;#include <delay.h>
;#include <string.h>
;
;#include "DEFINE.h"
;#include "fontR.h"
;
;
;
;//=============================   8  ===================================
;
;void lcd_write_cmd(unsigned char c){
; 0000 002E void lcd_write_cmd(unsigned char c){

	.CSEG
_lcd_write_cmd:
; CS=0;
;	c -> Y+0
	CBI  0x18,2
; DAT=0;//_Off;
	CBI  0x18,3
; CLK=1;//_On;
	RCALL SUBOPT_0x0
; CLK=0;//_Off;
;
; SPI_ON;
; SPDR = c;
; SPI_WAIT;
_0xB:
	SBIC 0xE,7
	RJMP _0xD
	RJMP _0xB
_0xD:
; SPI_OFF;
	RCALL SUBOPT_0x1
; CS=1;
;}
	RET
;
;
;
;//=============================   8  ====================================
;
;void lcd_write_dat(unsigned char c){
_lcd_write_dat:
; CS=0;
;	c -> Y+0
	CBI  0x18,2
; DAT=1;//_On;
	SBI  0x18,3
; CLK=1;//_On;
	RCALL SUBOPT_0x0
; CLK=0;//_Off;
;
; SPI_ON;
; SPDR = c;
; SPI_WAIT;
_0x18:
	SBIC 0xE,7
	RJMP _0x1A
	RJMP _0x18
_0x1A:
; SPI_OFF;
	RCALL SUBOPT_0x1
; CS=1;
;}
	RET
;
;//============================   16  ====================================
;
;void lcd_write16(unsigned int dat){
_lcd_write16:
;  lcd_write_dat(dat>>8);
;	dat -> Y+0
	LDD  R30,Y+1
	RCALL SUBOPT_0x2
;  lcd_write_dat(dat);
	LD   R30,Y
	RCALL SUBOPT_0x2
;}
	ADIW R28,2
	RET
;//================================ =========================================
;/*
;void lcd_init_rgb(void)
;{
;   CS= 0;
;   RESET=0;
;   delay_ms(5);
;   RESET=1;
;   delay_ms(5);
;   CS= 1;
;   delay_ms(5);       //reset
;
;
; lcd_write_cmd(0xBA); lcd_write_dat(0b00000111); lcd_write_dat(0b00010101);//Data Order
; lcd_write_cmd(0x25); lcd_write_dat(0b00111111); //Contrast
; lcd_write_cmd(0x36); lcd_write_dat(0b10100000);// < >,  RGB,
; lcd_write_cmd(0x11); //Sleep out
; lcd_write_cmd(0x13); //Displey Normal Mode
; lcd_write_cmd(0x37); lcd_write_dat(0b00000000); //VSROLL ADDR
; lcd_write_cmd(0x3A); lcd_write_dat(0b00000101);//16bit
; fill_screen(bgcolor);
; lcd_write_cmd(0x29);// DISP ON
; lcd_write_cmd(0x20);// INV OFF
; lcd_write_cmd(0x13);// NOR ON
; }
;*/
;
;
;
;void lcd_init_rgb(void)
;{
_lcd_init_rgb:
;
;  CS=0;//_Off;
	CBI  0x18,2
;  RESET=0;
	CBI  0x18,1
;  delay_ms(5);
	RCALL SUBOPT_0x3
;  RESET=1;
	SBI  0x18,1
;  delay_ms(5);
	RCALL SUBOPT_0x3
;  CS=1;//_On;
	SBI  0x18,2
;  lcd_write_cmd(0x01);
	RCALL SUBOPT_0x4
	RCALL _lcd_write_cmd
;  delay_ms(5);       //reset
	RCALL SUBOPT_0x3
;//  CS=0;//_Off;
;
;
;/*
;  lcd_write_cmd(0xBA); //   
;  lcd_write_dat(0x07);
;  lcd_write_dat(0x15);
;  lcd_write_cmd(0x25); // 
;  lcd_write_dat(0x3F);
;  lcd_write_cmd(0x11); //    sleep, (0x10) sleep
;  lcd_write_cmd(0x14);
;
;  lcd_write_cmd(0x37); //  
;  lcd_write_dat(0x00);
;  lcd_write_cmd(0x3A);
;  lcd_write_dat(0x05);
;
;  lcd_write_cmd(0x36); //  
;  lcd_write_dat(0xA0); //   90 
;
;  fill_screen(bgcolor);
;  lcd_write_cmd(0x29); //  , (0x28) 
;  lcd_write_cmd(0x20); //  , (0x21) 
;  lcd_write_cmd(0x13);
;*/
; //=======================   ========================================
; lcd_write_cmd(0x11); //Sleep out
	LDI  R30,LOW(17)
	RCALL SUBOPT_0x5
; lcd_write_cmd(0x3A); lcd_write_dat(0x05);//16bit05      COLMOD pixel format 04=12,05=16,06=18
	LDI  R30,LOW(58)
	RCALL SUBOPT_0x5
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x2
; lcd_write_cmd(0x36); lcd_write_dat(0xA0);
	LDI  R30,LOW(54)
	RCALL SUBOPT_0x5
	LDI  R30,LOW(160)
	RCALL SUBOPT_0x2
; fill_screen(bgcolor);
	RCALL SUBOPT_0x6
	RCALL _fill_screen
; lcd_write_cmd(0x29);// DISP ON
	LDI  R30,LOW(41)
	RCALL SUBOPT_0x5
; //==========================================================================
;// CS=0;
; }
	RET
;
;
;//=================================== ============================================
;
; void fill_screen(unsigned int color)
; {
_fill_screen:
;   unsigned char j,i;
;    lcd_write_cmd(0x2A); //x-
	RCALL __SAVELOCR2
;	color -> Y+2
;	j -> R17
;	i -> R16
	LDI  R30,LOW(42)
	RCALL SUBOPT_0x5
;    lcd_write16(1);
	RCALL SUBOPT_0x7
;    lcd_write16(160);
	LDI  R30,LOW(160)
	LDI  R31,HIGH(160)
	RCALL SUBOPT_0x8
;
;    lcd_write_cmd(0x2B);//Y-
	LDI  R30,LOW(43)
	RCALL SUBOPT_0x5
;    lcd_write16(1);
	RCALL SUBOPT_0x7
;    lcd_write16(131);
	LDI  R30,LOW(131)
	LDI  R31,HIGH(131)
	RCALL SUBOPT_0x8
;
;          lcd_write_cmd(0x2C);
	LDI  R30,LOW(44)
	RCALL SUBOPT_0x5
;
;  for (i=0; i<DISP_H; i++)
	LDI  R16,LOW(0)
_0x26:
	CPI  R16,131
	BRLO PC+2
	RJMP _0x27
;  {
;   for(j=0;j<DISP_W;j++)
	LDI  R17,LOW(0)
_0x29:
	CPI  R17,160
	BRLO PC+2
	RJMP _0x2A
;   {
;    lcd_write16(color);
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x8
;   }
_0x28:
	SUBI R17,-1
	RJMP _0x29
_0x2A:
;  }
_0x25:
	SUBI R16,-1
	RJMP _0x26
_0x27:
; }
	RCALL __LOADLOCR2
	ADIW R28,4
	RET
;
;
;
;
;
;void LCD_XY(unsigned char x, unsigned char y)
; {
_LCD_XY:
;    lcd_write_cmd(0x2A); //x-
;	x -> Y+1
;	y -> Y+0
	LDI  R30,LOW(42)
	RCALL SUBOPT_0x5
;    lcd_write16(x+2);
	RCALL SUBOPT_0x9
;    lcd_write16(x+2);
	RCALL SUBOPT_0x9
;
;    lcd_write_cmd(0x2B);//Y-
	LDI  R30,LOW(43)
	RCALL SUBOPT_0x5
;    lcd_write16(y+1);
	RCALL SUBOPT_0xA
;    lcd_write16(y+1);
	RCALL SUBOPT_0xA
; }
	ADIW R28,2
	RET
;
;
;
;void LCD_Pixel(char x, char y,int color)
; {
_LCD_Pixel:
;  LCD_XY(x,y);
;	x -> Y+3
;	y -> Y+2
;	color -> Y+0
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	RCALL _LCD_XY
;  lcd_write_cmd(0x2C);// WR_MEM
	LDI  R30,LOW(44)
	RCALL SUBOPT_0x5
;
;  lcd_write16(color);
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x8
;
; }
	ADIW R28,4
	RET
;
;
;void LCD_Char(unsigned char x, unsigned char y, char c, unsigned int color,char m)
;{
_LCD_Char:
;  unsigned char h,ch,p,mask,tt;
;
;    lcd_write_cmd(0x2A); //x-
	RCALL __SAVELOCR6
;	x -> Y+11
;	y -> Y+10
;	c -> Y+9
;	color -> Y+7
;	m -> Y+6
;	h -> R17
;	ch -> R16
;	p -> R19
;	mask -> R18
;	tt -> R21
	LDI  R30,LOW(42)
	RCALL SUBOPT_0x5
;    lcd_write16(x+2);
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x8
;    lcd_write16(x+2+CHAR_W*m-1);
	RCALL SUBOPT_0xB
	MOVW R22,R30
	LDD  R30,Y+6
	LDI  R26,LOW(8)
	RCALL SUBOPT_0xC
;
;    lcd_write_cmd(0x2B);//Y-
	LDI  R30,LOW(43)
	RCALL SUBOPT_0x5
;    lcd_write16(y+1);
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x8
;    lcd_write16(y+1+CHAR_H*m-1);
	RCALL SUBOPT_0xD
	MOVW R22,R30
	LDD  R30,Y+6
	LDI  R26,LOW(11)
	RCALL SUBOPT_0xC
;
;
;      lcd_write_cmd(0x2C);
	LDI  R30,LOW(44)
	RCALL SUBOPT_0x5
;
;
;
;
;
;
; // for (h=0; h<CHAR_H*m; h++) // every column of the character
; // {
; //         ch=FONT8x14[ c-32 ][h/m];
;
;    for (h=CHAR_H; h>0; h--) {    // every column of the character
	LDI  R17,LOW(11)
_0x2C:
	CPI  R17,1
	BRSH PC+2
	RJMP _0x2D
;
;    for(tt=0;tt<m;tt++) {
	LDI  R21,LOW(0)
_0x2F:
	LDD  R30,Y+6
	CP   R21,R30
	BRLO PC+2
	RJMP _0x30
;
;
;
;
;
;      if (c == 32) {
	LDD  R26,Y+9
	CPI  R26,LOW(0x20)
	BREQ PC+2
	RJMP _0x31
;        ch=ascii_tab[0][CHAR_H-h];
	RCALL SUBOPT_0xE
	SUBI R30,LOW(-_ascii_tab_G000*2)
	SBCI R31,HIGH(-_ascii_tab_G000*2)
	LPM  R16,Z
;      }
;
;      else if (c > 44 && c < 59) {
	RJMP _0x32
_0x31:
	LDD  R26,Y+9
	CPI  R26,LOW(0x2D)
	BRSH PC+2
	RJMP _0x34
	CPI  R26,LOW(0x3B)
	BRLO PC+2
	RJMP _0x34
	RJMP _0x35
_0x34:
	RJMP _0x33
_0x35:
;        ch=ascii_tab[c-44][CHAR_H-h];
	RCALL SUBOPT_0xF
	SBIW R30,44
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x11
;      }
;
;      else if (c == 176) {
	RJMP _0x36
_0x33:
	LDD  R26,Y+9
	CPI  R26,LOW(0xB0)
	BREQ PC+2
	RJMP _0x37
;        ch=ascii_tab[15][CHAR_H-h];
	__POINTWRFN 22,23,_ascii_tab_G000,165
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x11
;      }
;
;      else if (c > 191) {
	RJMP _0x38
_0x37:
	LDD  R26,Y+9
	CPI  R26,LOW(0xC0)
	BRSH PC+2
	RJMP _0x39
;        ch=ascii_tab[c-176][CHAR_H-h];
	RCALL SUBOPT_0xF
	SUBI R30,LOW(176)
	SBCI R31,HIGH(176)
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x11
;      }
;
;
;        mask = 0x80;
_0x39:
_0x38:
_0x36:
_0x32:
	LDI  R18,LOW(128)
;
;        for (p=0; p<CHAR_W; p++)  // write the pixels
	LDI  R19,LOW(0)
_0x3B:
	CPI  R19,8
	BRLO PC+2
	RJMP _0x3C
;        {
;          if (ch & mask)
	MOV  R30,R18
	AND  R30,R16
	BRNE PC+2
	RJMP _0x3D
;          {
;           lcd_write16(color);
	RCALL SUBOPT_0x12
;           if(m==2)
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x3E
;           { lcd_write16(color); }
	RCALL SUBOPT_0x12
;           if(m==3)
_0x3E:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3)
	BREQ PC+2
	RJMP _0x3F
;           { lcd_write16(color);lcd_write16(color); }
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
;          }
_0x3F:
;
;          else
	RJMP _0x40
_0x3D:
;          {
;           lcd_write16(bgcolor);
	RCALL SUBOPT_0x6
	RCALL _lcd_write16
;           if(m==2)
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BREQ PC+2
	RJMP _0x41
;           { lcd_write16(bgcolor);}
	RCALL SUBOPT_0x6
	RCALL _lcd_write16
;           if(m==3)
_0x41:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3)
	BREQ PC+2
	RJMP _0x42
;           { lcd_write16(bgcolor); lcd_write16(bgcolor);}
	RCALL SUBOPT_0x6
	RCALL _lcd_write16
	RCALL SUBOPT_0x6
	RCALL _lcd_write16
;
;          }
_0x42:
_0x40:
;          mask=mask/2;
	MOV  R26,R18
	RCALL SUBOPT_0x13
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL __DIVW21
	MOV  R18,R30
;        }
_0x3A:
	SUBI R19,-1
	RJMP _0x3B
_0x3C:
;  } }
_0x2E:
	SUBI R21,-1
	RJMP _0x2F
_0x30:
_0x2B:
	SUBI R17,1
	RJMP _0x2C
_0x2D:
;
;}
	RCALL __LOADLOCR6
	ADIW R28,12
	RET
;
;void put_string(unsigned char x, unsigned char y, char *str, unsigned int color,char m)
;{
_put_string:
; unsigned char j;
;  j=0;
	ST   -Y,R17
;	x -> Y+7
;	y -> Y+6
;	*str -> Y+4
;	color -> Y+2
;	m -> Y+1
;	j -> R17
	LDI  R17,LOW(0)
;  while (j<strlen(str))
_0x43:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	RCALL SUBOPT_0x14
	RCALL _strlen
	MOV  R26,R17
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x15
	BRLO PC+2
	RJMP _0x45
;  {
;    LCD_Char(x+j*CHAR_W*m,y,str[j], color,m);
	MOV  R30,R17
	LSL  R30
	LSL  R30
	LSL  R30
	LDD  R26,Y+1
	MULS R30,R26
	MOVW R30,R0
	LDD  R26,Y+7
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+7
	ST   -Y,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	RCALL SUBOPT_0x14
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _LCD_Char
;    j++;
	SUBI R17,-1
;  }
	RJMP _0x43
_0x45:
;}
	LDD  R17,Y+0
	ADIW R28,8
	RET
;
;
;
;  void lcd_line(char x1,char y1,char x2,char y2,unsigned int color)
;{
_lcd_line:
;
;signed int  x,y,d,dx,dy,i,i1,i2,kx,ky;
;signed char  flag;
;
;dx = x2 - x1;
	SBIW R28,15
	RCALL __SAVELOCR6
;	x1 -> Y+26
;	y1 -> Y+25
;	x2 -> Y+24
;	y2 -> Y+23
;	color -> Y+21
;	x -> R16,R17
;	y -> R18,R19
;	d -> R20,R21
;	dx -> Y+19
;	dy -> Y+17
;	i -> Y+15
;	i1 -> Y+13
;	i2 -> Y+11
;	kx -> Y+9
;	ky -> Y+7
;	flag -> Y+6
	LDD  R26,Y+24
	CLR  R27
	LDD  R30,Y+26
	RCALL SUBOPT_0x16
	STD  Y+19,R26
	STD  Y+19+1,R27
;dy = y2 - y1;
	LDD  R26,Y+23
	CLR  R27
	LDD  R30,Y+25
	RCALL SUBOPT_0x16
	STD  Y+17,R26
	STD  Y+17+1,R27
;if (dx == 0 && dy == 0) LCD_Pixel(x1, y1, color);
	RCALL SUBOPT_0x17
	SBIW R26,0
	BREQ PC+2
	RJMP _0x47
	LDD  R26,Y+17
	LDD  R27,Y+17+1
	SBIW R26,0
	BREQ PC+2
	RJMP _0x47
	RJMP _0x48
_0x47:
	RJMP _0x46
_0x48:
	LDD  R30,Y+26
	ST   -Y,R30
	LDD  R30,Y+26
	ST   -Y,R30
	RCALL SUBOPT_0x18
;else
	RJMP _0x49
_0x46:
;{
;kx = 1;
	RCALL SUBOPT_0x19
	STD  Y+9,R30
	STD  Y+9+1,R31
;ky = 1;
	RCALL SUBOPT_0x19
	STD  Y+7,R30
	STD  Y+7+1,R31
;if( dx < 0 )
	LDD  R26,Y+20
	TST  R26
	BRMI PC+2
	RJMP _0x4A
;{
;dx = -dx;
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	RCALL __ANEGW1
	STD  Y+19,R30
	STD  Y+19+1,R31
;kx = -1;
	RCALL SUBOPT_0x1A
	STD  Y+9,R30
	STD  Y+9+1,R31
;}
;else
	RJMP _0x4B
_0x4A:
;if(dx == 0) kx = 0;
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	SBIW R30,0
	BREQ PC+2
	RJMP _0x4C
	LDI  R30,LOW(0)
	STD  Y+9,R30
	STD  Y+9+1,R30
;if(dy < 0)
_0x4C:
_0x4B:
	LDD  R26,Y+18
	TST  R26
	BRMI PC+2
	RJMP _0x4D
;{
;dy = -dy;
	RCALL SUBOPT_0x1B
	RCALL __ANEGW1
	STD  Y+17,R30
	STD  Y+17+1,R31
;ky = -1;
	RCALL SUBOPT_0x1A
	STD  Y+7,R30
	STD  Y+7+1,R31
;}
;if(dx < dy)
_0x4D:
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x15
	BRLT PC+2
	RJMP _0x4E
;{
;flag = 0;
	LDI  R30,LOW(0)
	STD  Y+6,R30
;d = dx;
	__GETWRS 20,21,19
;dx = dy;
	RCALL SUBOPT_0x1B
	STD  Y+19,R30
	STD  Y+19+1,R31
;dy = d;
	__PUTWSR 20,21,17
;}
;else flag = 1;
	RJMP _0x4F
_0x4E:
	LDI  R30,LOW(1)
	STD  Y+6,R30
;i1 = dy + dy;
_0x4F:
	RCALL SUBOPT_0x1B
	LSL  R30
	ROL  R31
	STD  Y+13,R30
	STD  Y+13+1,R31
;d = i1 - dx;
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x1C
	SUB  R30,R26
	SBC  R31,R27
	MOVW R20,R30
;i2 = d - dx;
	RCALL SUBOPT_0x17
	MOVW R30,R20
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+11,R30
	STD  Y+11+1,R31
;x = x1;
	LDD  R16,Y+26
	CLR  R17
;y = y1;
	LDD  R18,Y+25
	CLR  R19
;
;for(i=0; i < dx; i++)
	LDI  R30,LOW(0)
	STD  Y+15,R30
	STD  Y+15+1,R30
_0x51:
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	LDD  R26,Y+15
	LDD  R27,Y+15+1
	RCALL SUBOPT_0x15
	BRLT PC+2
	RJMP _0x52
;{
;LCD_Pixel(x, y, color);
	ST   -Y,R16
	ST   -Y,R18
	RCALL SUBOPT_0x18
;if(flag) x += kx;
	LDD  R30,Y+6
	CPI  R30,0
	BRNE PC+2
	RJMP _0x53
	RCALL SUBOPT_0x1D
;else y += ky;
	RJMP _0x54
_0x53:
	RCALL SUBOPT_0x1E
;if( d < 0 ) d += i1;
_0x54:
	TST  R21
	BRMI PC+2
	RJMP _0x55
	RCALL SUBOPT_0x1C
	__ADDWRR 20,21,30,31
;else
	RJMP _0x56
_0x55:
;{
;d += i2;
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	__ADDWRR 20,21,30,31
;if(flag) y += ky;
	LDD  R30,Y+6
	CPI  R30,0
	BRNE PC+2
	RJMP _0x57
	RCALL SUBOPT_0x1E
;else x += kx;
	RJMP _0x58
_0x57:
	RCALL SUBOPT_0x1D
;}
_0x58:
_0x56:
;}
_0x50:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ADIW R30,1
	STD  Y+15,R30
	STD  Y+15+1,R31
	RJMP _0x51
_0x52:
;LCD_Pixel(x, y, color);
	ST   -Y,R16
	ST   -Y,R18
	RCALL SUBOPT_0x18
;}
_0x49:
;}
	RCALL __LOADLOCR6
	ADIW R28,27
	RET
;char convert[32];
;
;///menu
;#define ROB          1
;#define FORS         2
;#define voltmode     3
;#define PROBEG       4
;#define DS           5
;#define SP           6
;#define a         7
;#define b         8
;#define c         9
;#define d         10
;#define e           11
;#define f           12
;int mode;
;
;// External Interrupt 1 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0042 {
_ext_int0_isr:
	RCALL SUBOPT_0x1F
; 0000 0043 ts++;
	INC  R8
; 0000 0044 im1 = im1+1;
	RCALL SUBOPT_0x20
	ADIW R30,1
	RCALL SUBOPT_0x21
; 0000 0045 if (im1>=ds)
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x15
	BRSH PC+2
	RJMP _0x59
; 0000 0046  {
; 0000 0047  im1=0;
	RCALL SUBOPT_0x24
; 0000 0048  dat1=dat1+1;
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x27
; 0000 0049  dat6=dat6+1;
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x29
; 0000 004A  };}
_0x59:
	RCALL SUBOPT_0x2A
	RETI
;
;// External Interrupt 0 service routine
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 004E {
_ext_int1_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 004F tsP++;
	INC  R7
; 0000 0050 if(PIND.3) TCCR1B=0x02;
	SBIS 0x10,3
	RJMP _0x5A
	LDI  R30,LOW(2)
	OUT  0x2E,R30
; 0000 0051 else TCCR1B=0x00;
	RJMP _0x5B
_0x5A:
	LDI  R30,LOW(0)
	OUT  0x2E,R30
; 0000 0052 }
_0x5B:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;void out(void)
; 0000 0055 {
_out:
; 0000 0056 // 
; 0000 0057 z++;
	INC  R12
; 0000 0058 if(z==20) {z=0; rx=trx; trx=0;};
	LDI  R30,LOW(20)
	CP   R30,R12
	BREQ PC+2
	RJMP _0x5C
	CLR  R12
	LDS  R5,_trx
	LDI  R30,LOW(0)
	STS  _trx,R30
_0x5C:
; 0000 0059 
; 0000 005A if(speed>200)speed = 0;
	RCALL SUBOPT_0x2B
	CPI  R26,LOW(0xC9)
	LDI  R30,HIGH(0xC9)
	CPC  R27,R30
	BRSH PC+2
	RJMP _0x5D
	LDI  R30,LOW(0)
	STS  _speed,R30
	STS  _speed+1,R30
; 0000 005B if(speed>9) park=0;
_0x5D:
	RCALL SUBOPT_0x2B
	SBIW R26,10
	BRSH PC+2
	RJMP _0x5E
	CLT
	BLD  R2,0
; 0000 005C else park=1;
	RJMP _0x5F
_0x5E:
	SET
	BLD  R2,0
; 0000 005D //if(speed>0) park=0;
; 0000 005E //else park=1;
; 0000 005F mrr=(float)rx/(float)speed*100; //   /100
_0x5F:
	MOV  R30,R5
	RCALL SUBOPT_0x2C
	RCALL __CWD1
	RCALL __CDF1
	RCALL SUBOPT_0x2D
	LDS  R30,_speed
	LDS  R31,_speed+1
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __DIVF21
	__GETD2N 0x42C80000
	RCALL __MULF12
	LDI  R26,LOW(_mrr)
	LDI  R27,HIGH(_mrr)
	RCALL __CFD1U
	ST   X+,R30
	ST   X,R31
; 0000 0060 x++;
	INC  R10
; 0000 0061 //  x = (a + b / 2) / b      (7740+600/2)/600      13,4
; 0000 0062 //dsl=13200/ds;
; 0000 0063 dsl=(7740+ds/2)/ds;
	RCALL SUBOPT_0x22
	LSR  R31
	ROR  R30
	SUBI R30,LOW(-7740)
	SBCI R31,HIGH(-7740)
	MOVW R26,R30
	RCALL SUBOPT_0x22
	RCALL __DIVW21U
	STS  _dsl,R30
	STS  _dsl+1,R31
; 0000 0064 if(x==dsl) {x=0; speed=ts; ts=0;};
	MOV  R26,R10
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x2E
	BREQ PC+2
	RJMP _0x60
	CLR  R10
	MOV  R30,R8
	RCALL SUBOPT_0x2C
	STS  _speed,R30
	STS  _speed+1,R31
	CLR  R8
_0x60:
; 0000 0065 if(speedP == 0)TCCR1B=0x00;
	LDS  R30,_speedP
	LDS  R31,_speedP+1
	SBIW R30,0
	BREQ PC+2
	RJMP _0x61
	LDI  R30,LOW(0)
	OUT  0x2E,R30
; 0000 0066 xP++;
_0x61:
	INC  R6
; 0000 0067 if(xP==10) {xP=0; speedP=tsP; tsP=0;};
	LDI  R30,LOW(10)
	CP   R30,R6
	BREQ PC+2
	RJMP _0x62
	CLR  R6
	MOV  R30,R7
	RCALL SUBOPT_0x2C
	STS  _speedP,R30
	STS  _speedP+1,R31
	CLR  R7
_0x62:
; 0000 0068  }
	RET
;
; // Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 006C {
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 006D n++;
	LDI  R26,LOW(_n)
	LDI  R27,HIGH(_n)
	RCALL SUBOPT_0x2F
; 0000 006E if(n==360) {n=0; out();};
	LDS  R26,_n
	LDS  R27,_n+1
	CPI  R26,LOW(0x168)
	LDI  R30,HIGH(0x168)
	CPC  R27,R30
	BREQ PC+2
	RJMP _0x63
	LDI  R30,LOW(0)
	STS  _n,R30
	STS  _n+1,R30
	RCALL _out
_0x63:
; 0000 006F }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// Timer 1 overflow interrupt service routine
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 0073 {
_timer1_ovf_isr:
	RCALL SUBOPT_0x1F
; 0000 0074 TCNT1=PrFors; //64744;;//fcf8 //fors
	RCALL SUBOPT_0x30
	OUT  0x2C+1,R31
	OUT  0x2C,R30
; 0000 0075 r++;
	INC  R4
; 0000 0076 tm++;
	INC  R11
; 0000 0077 y++;
	INC  R13
; 0000 0078 if(y==3)
	LDI  R30,LOW(3)
	CP   R30,R13
	BREQ PC+2
	RJMP _0x64
; 0000 0079 {
; 0000 007A trx++;
	LDS  R30,_trx
	SUBI R30,-LOW(1)
	STS  _trx,R30
; 0000 007B y=0;
	CLR  R13
; 0000 007C };
_0x64:
; 0000 007D dat2++;
	LDI  R26,LOW(_dat2)
	LDI  R27,HIGH(_dat2)
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
; 0000 007E }
	RCALL SUBOPT_0x2A
	RETI
;
;
;#define ADC_VREF_TYPE 0x20
;
;// Read the 8 most significant bits
;// of the AD conversion result
;unsigned char read_adc(unsigned char adc_input)
; 0000 0086 {
_read_adc:
; 0000 0087 ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,0x20
	OUT  0x7,R30
; 0000 0088 //delay_us(10);
; 0000 0089 ADCSRA|=0x40;
	SBI  0x6,6
; 0000 008A while ((ADCSRA & 0x10)==0);
_0x65:
	SBIC 0x6,4
	RJMP _0x67
	RJMP _0x65
_0x67:
; 0000 008B ADCSRA|=0x10;
	SBI  0x6,4
; 0000 008C return ADCH;
	IN   R30,0x5
	ADIW R28,1
	RET
; 0000 008D }
;
;
;
;void main(void)
; 0000 0092 {
_main:
; 0000 0093 // Declare your local variables here
; 0000 0094 
; 0000 0095 // Input/Output Ports initialization
; 0000 0096 // Port B initialization
; 0000 0097 // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In
; 0000 0098 // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=T
; 0000 0099 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 009A DDRB=0x3E;
	LDI  R30,LOW(62)
	OUT  0x17,R30
; 0000 009B 
; 0000 009C // Port C initialization
; 0000 009D // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out
; 0000 009E // State6=T State5=T State4=T State3=T State2=T State1=T State0=1
; 0000 009F PORTC=0x01;
	LDI  R30,LOW(1)
	OUT  0x15,R30
; 0000 00A0 DDRC=0x01;
	OUT  0x14,R30
; 0000 00A1 
; 0000 00A2 
; 0000 00A3 // Port D initialization
; 0000 00A4 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00A5 // State7=P State6=P State5=P State4=T State3=T State2=P State1=T State0=T
; 0000 00A6 PORTD=0xE4;
	LDI  R30,LOW(228)
	OUT  0x12,R30
; 0000 00A7 DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0000 00A8 
; 0000 00A9 // Timer/Counter 0 initialization
; 0000 00AA // Clock source: System Clock
; 0000 00AB // Clock value: 1000,0 kHz
; 0000 00AC TCCR0=0x02;
	LDI  R30,LOW(2)
	OUT  0x33,R30
; 0000 00AD TCNT0=0;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00AE 
; 0000 00AF // Timer/Counter 1 initialization
; 0000 00B0 // Clock source: System Clock
; 0000 00B1 // Clock value: 1000,0 kHz
; 0000 00B2 // Mode: Normal top=FFFFh
; 0000 00B3 // OC1A output: Discon.
; 0000 00B4 // OC1B output: Discon.
; 0000 00B5 // Noise Canceler: Off
; 0000 00B6 // Input Capture on Falling Edge
; 0000 00B7 // Timer 1 Overflow Interrupt: On
; 0000 00B8 // Input Capture Interrupt: Off
; 0000 00B9 // Compare A Match Interrupt: Off
; 0000 00BA // Compare B Match Interrupt: Off
; 0000 00BB TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00BC TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00BD 
; 0000 00BE TCNT1H=0xFC;
	LDI  R30,LOW(252)
	OUT  0x2D,R30
; 0000 00BF TCNT1L=0xD0;
	LDI  R30,LOW(208)
	OUT  0x2C,R30
; 0000 00C0 
; 0000 00C1 ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x27,R30
; 0000 00C2 ICR1L=0x00;
	OUT  0x26,R30
; 0000 00C3 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00C4 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00C5 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00C6 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00C7 
; 0000 00C8 // Timer/Counter 2 initialization
; 0000 00C9 // Clock source: System Clock
; 0000 00CA // Clock value: 11059,200 kHz
; 0000 00CB // Mode: Normal top=FFh
; 0000 00CC // OC2 output: Disconnected
; 0000 00CD ASSR=0x00;
	OUT  0x22,R30
; 0000 00CE TCCR2=0x00;
	OUT  0x25,R30
; 0000 00CF TCNT2=0x00;
	OUT  0x24,R30
; 0000 00D0 OCR2=0x00;
	OUT  0x23,R30
; 0000 00D1 
; 0000 00D2 // External Interrupt(s) initialization
; 0000 00D3 // INT0: On
; 0000 00D4 // INT0 Mode: Any change
; 0000 00D5 // INT1: On
; 0000 00D6 // INT1 Mode: Any change
; 0000 00D7 //GICR|=0xC0;
; 0000 00D8 //MCUCR=0x0D;
; 0000 00D9 //GIFR=0xC0;
; 0000 00DA 
; 0000 00DB GICR|=0xC0;
	IN   R30,0x3B
	ORI  R30,LOW(0xC0)
	OUT  0x3B,R30
; 0000 00DC MCUCR=0x07;//06
	LDI  R30,LOW(7)
	OUT  0x35,R30
; 0000 00DD GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
; 0000 00DE 
; 0000 00DF // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00E0 TIMSK=0x05;
	LDI  R30,LOW(5)
	OUT  0x39,R30
; 0000 00E1 
; 0000 00E2 // Analog Comparator initialization
; 0000 00E3 // Analog Comparator: Off
; 0000 00E4 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00E5 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00E6 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00E7 
; 0000 00E8 // ADC initialization
; 0000 00E9 // ADC Clock frequency: 691,200 kHz
; 0000 00EA // ADC Voltage Reference: AREF pin
; 0000 00EB // Only the 8 most significant bits of
; 0000 00EC // the AD conversion result are used
; 0000 00ED ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(32)
	OUT  0x7,R30
; 0000 00EE ADCSRA=0x84;
	LDI  R30,LOW(132)
	OUT  0x6,R30
; 0000 00EF 
; 0000 00F0 // SPI initialization
; 0000 00F1 // SPI Type: Master
; 0000 00F2 // SPI Clock Rate: 2*4000,000 kHz
; 0000 00F3 // SPI Clock Phase: Cycle Start
; 0000 00F4 // SPI Clock Polarity: Low
; 0000 00F5 // SPI Data Order: MSB First
; 0000 00F6 SPCR=0x50;
	LDI  R30,LOW(80)
	OUT  0xD,R30
; 0000 00F7 SPSR=0x01;
	LDI  R30,LOW(1)
	OUT  0xE,R30
; 0000 00F8 
; 0000 00F9 // TWI initialization
; 0000 00FA // TWI disabled
; 0000 00FB TWCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x36,R30
; 0000 00FC 
; 0000 00FD // Global enable interrupts
; 0000 00FE #asm("sei")
	sei
; 0000 00FF bgcolor=0x0000;
	LDI  R30,LOW(0)
	STS  _bgcolor,R30
	STS  _bgcolor+1,R30
; 0000 0100 lcd_init_rgb();
	RCALL _lcd_init_rgb
; 0000 0101 delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x31
; 0000 0102 dat1=data1;
	LDI  R26,LOW(_data1)
	LDI  R27,HIGH(_data1)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x27
; 0000 0103 dat6=data6;
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x29
; 0000 0104 dat2=data2;
	LDI  R26,LOW(_data2)
	LDI  R27,HIGH(_data2)
	RCALL __EEPROMRDD
	STS  _dat2,R30
	STS  _dat2+1,R31
	STS  _dat2+2,R22
	STS  _dat2+3,R23
; 0000 0105 PrFors=eepromPrFors;
	LDI  R26,LOW(_eepromPrFors)
	LDI  R27,HIGH(_eepromPrFors)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x34
; 0000 0106 voltag=eepromvolt;
	LDI  R26,LOW(_eepromvolt)
	LDI  R27,HIGH(_eepromvolt)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x35
; 0000 0107 ds=eepromDS;
	LDI  R26,LOW(_eepromDS)
	LDI  R27,HIGH(_eepromDS)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x36
; 0000 0108 im1=eeim1;
	LDI  R26,LOW(_eeim1)
	LDI  R27,HIGH(_eeim1)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x21
; 0000 0109 MOD=eeMOD;
	LDI  R26,LOW(_eeMOD)
	LDI  R27,HIGH(_eeMOD)
	RCALL __EEPROMRDB
	MOV  R9,R30
; 0000 010A mode = ROB;
	RCALL SUBOPT_0x37
; 0000 010B while (1)
_0x68:
; 0000 010C       {
; 0000 010D 
; 0000 010E if (read_adc(1)<50)
	RCALL SUBOPT_0x4
	RCALL _read_adc
	CPI  R30,LOW(0x32)
	BRLO PC+2
	RJMP _0x6B
; 0000 010F {
; 0000 0110 if (dat1!=data1) data1=dat1;
	LDI  R26,LOW(_data1)
	LDI  R27,HIGH(_data1)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x32
	RCALL __CPD12
	BRNE PC+2
	RJMP _0x6C
	LDS  R30,_dat1
	LDS  R31,_dat1+1
	LDI  R26,LOW(_data1)
	LDI  R27,HIGH(_data1)
	RCALL __EEPROMWRW
; 0000 0111 if (dat2!=data2) data2=dat2;
_0x6C:
	LDI  R26,LOW(_data2)
	LDI  R27,HIGH(_data2)
	RCALL __EEPROMRDD
	RCALL SUBOPT_0x39
	RCALL __CPD12
	BRNE PC+2
	RJMP _0x6D
	LDS  R30,_dat2
	LDS  R31,_dat2+1
	LDS  R22,_dat2+2
	LDS  R23,_dat2+3
	LDI  R26,LOW(_data2)
	LDI  R27,HIGH(_data2)
	RCALL __EEPROMWRD
; 0000 0112 if (dat6!=data6) data6=dat6;
_0x6D:
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x3A
	RCALL __CPD12
	BRNE PC+2
	RJMP _0x6E
	RCALL SUBOPT_0x3B
; 0000 0113 if (im1!=eeim1) eeim1=im1;
_0x6E:
	LDI  R26,LOW(_eeim1)
	LDI  R27,HIGH(_eeim1)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x2E
	BRNE PC+2
	RJMP _0x6F
	RCALL SUBOPT_0x20
	LDI  R26,LOW(_eeim1)
	LDI  R27,HIGH(_eeim1)
	RCALL __EEPROMWRW
; 0000 0114 delay_ms(1000);
_0x6F:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x31
; 0000 0115 PORTC.0=0;
	CBI  0x15,0
; 0000 0116 };
_0x6B:
; 0000 0117 //--//
; 0000 0118 if (dat1 > 9999){ dat1 = 0;}        // 
	RCALL SUBOPT_0x38
	__CPD2N 0x2710
	BRSH PC+2
	RJMP _0x72
	RCALL SUBOPT_0x3C
; 0000 0119 if (dat6 > 9999999){ dat6 = 0;}     // 
_0x72:
	RCALL SUBOPT_0x3A
	__CPD2N 0x989680
	BRSH PC+2
	RJMP _0x73
	LDI  R30,LOW(0)
	STS  _dat6,R30
	STS  _dat6+1,R30
	STS  _dat6+2,R30
	STS  _dat6+3,R30
; 0000 011A dat3=(dat2/1000)/MOD;                    //  
_0x73:
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3D
	MOV  R30,R9
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x3E
	RCALL __DIVD21U
	STS  _dat3,R30
	STS  _dat3+1,R31
	STS  _dat3+2,R22
	STS  _dat3+3,R23
; 0000 011B 
; 0000 011C volt=read_adc(1);
	RCALL SUBOPT_0x4
	RCALL _read_adc
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL SUBOPT_0x3F
; 0000 011D volt=((volt*1000)*(voltag+600))/1000000;
	LDS  R30,_volt
	LDS  R31,_volt+1
	LDS  R22,_volt+2
	LDS  R23,_volt+3
	__GETD2N 0x3E8
	RCALL __MULD12U
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x40
	__ADDD1N 600
	RCALL __MULD12U
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x3F
; 0000 011E 
; 0000 011F ///========================================================
; 0000 0120   switch (mode) {                                  //   
	RCALL SUBOPT_0x42
; 0000 0121   case ROB:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x76
; 0000 0122 
; 0000 0123   if (first_draw == 1) {                       //     ,    
	SBRS R2,1
	RJMP _0x78
; 0000 0124   lcd_line(0,21,60,21,brown);
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x46
; 0000 0125   lcd_line(0,20,60,20,brown);
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x46
; 0000 0126   lcd_line(0,55,160,55,brown);
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x46
; 0000 0127   lcd_line(0,56,160,56,brown);
	LDI  R30,LOW(56)
	RCALL SUBOPT_0x4A
	LDI  R30,LOW(56)
	ST   -Y,R30
	RCALL SUBOPT_0x46
; 0000 0128   lcd_line(0,110,160,110,brown);
	LDI  R30,LOW(110)
	RCALL SUBOPT_0x4A
	LDI  R30,LOW(110)
	ST   -Y,R30
	RCALL SUBOPT_0x46
; 0000 0129   lcd_line(0,111,160,111,brown);
	LDI  R30,LOW(111)
	RCALL SUBOPT_0x4A
	LDI  R30,LOW(111)
	RCALL SUBOPT_0x4B
; 0000 012A   lcd_line(100,79,160,79,brown);
	LDI  R30,LOW(79)
	RCALL SUBOPT_0x4A
	LDI  R30,LOW(79)
	RCALL SUBOPT_0x4B
; 0000 012B   lcd_line(100,80,160,80,brown);
	LDI  R30,LOW(80)
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x4D
; 0000 012C   lcd_line(80,20,80,55,brown);
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x4D
; 0000 012D   lcd_line(81,20,81,55,brown);
	LDI  R30,LOW(81)
	ST   -Y,R30
	RCALL SUBOPT_0x47
	LDI  R30,LOW(81)
	ST   -Y,R30
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x4D
; 0000 012E   lcd_line(55,21,80,21,brown);
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x4D
; 0000 012F   lcd_line(55,20,80,20,brown);
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x4D
; 0000 0130   put_string(3,6,"",RED,1);
	RCALL SUBOPT_0x4E
	LDI  R30,LOW(6)
	ST   -Y,R30
	__POINTW1MN _0x79,0
	RCALL SUBOPT_0x4F
	RCALL _put_string
; 0000 0131   put_string(100,60,"",RED,1);
	LDI  R30,LOW(100)
	ST   -Y,R30
	RCALL SUBOPT_0x45
	__POINTW1MN _0x79,8
	RCALL SUBOPT_0x4F
	RCALL _put_string
; 0000 0132   put_string(55,23,"",WHITE,1);
	RCALL SUBOPT_0x48
	LDI  R30,LOW(23)
	ST   -Y,R30
	__POINTW1MN _0x79,11
	RCALL SUBOPT_0x50
	RCALL _put_string
; 0000 0133   put_string(55,37,"/",WHITE,1);
	RCALL SUBOPT_0x48
	LDI  R30,LOW(37)
	ST   -Y,R30
	__POINTW1MN _0x79,14
	RCALL SUBOPT_0x50
	RCALL _put_string
; 0000 0134   first_draw = 0;};
	CLT
	BLD  R2,1
_0x78:
; 0000 0135 
; 0000 0136  //
; 0000 0137  sprintf(convert,"%d%d.%d",(volt/100)%10,(volt/10)%10,volt%10);
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x14
	__POINTW1FN _0x0,17
	RCALL SUBOPT_0x52
; 0000 0138  put_string(115,60,convert,WHITE,1);
	LDI  R30,LOW(115)
	ST   -Y,R30
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x53
	RCALL SUBOPT_0x54
; 0000 0139  sprintf(convert,"%d%d%d",(speed/100)%10,(speed/10)%10,speed%10);
	__POINTW1FN _0x0,26
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x58
; 0000 013A  put_string(3,25,convert,YELLOW,2); //24,30
	LDI  R30,LOW(25)
	RCALL SUBOPT_0x59
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL SUBOPT_0x54
; 0000 013B  // 
; 0000 013C  sprintf(convert,"%d%d.%d%d.",(dat3/1000)%10,(dat3/100)%10,(dat3/10)%10,dat3%10);
	__POINTW1FN _0x0,33
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x5D
	RCALL SUBOPT_0x5E
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x60
; 0000 013D  put_string(85,33,convert,WHITE,1);
	LDI  R30,LOW(33)
	RCALL SUBOPT_0x61
	RCALL _put_string
; 0000 013E 
; 0000 013F if (dat1<=9) //  
	RCALL SUBOPT_0x38
	__CPD2N 0xA
	BRLO PC+2
	RJMP _0x7A
; 0000 0140  {resu=0;}
	RCALL SUBOPT_0x62
; 0000 0141  else {
	RJMP _0x7B
_0x7A:
; 0000 0142  resu=((dat3*100)/dat1)*100;
	LDS  R30,_dat3
	LDS  R31,_dat3+1
	LDS  R22,_dat3+2
	LDS  R23,_dat3+3
	RCALL SUBOPT_0x63
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x25
	RCALL __DIVD21U
	RCALL SUBOPT_0x63
	STS  _resu,R30
	STS  _resu+1,R31
	STS  _resu+2,R22
	STS  _resu+3,R23
; 0000 0143  }
_0x7B:
; 0000 0144 
; 0000 0145 sprintf(convert,"%d%d.%d/100",(resu/10000)%10,(resu/1000)%10,(resu/100)%10,(resu/100)%10);
	RCALL SUBOPT_0x64
	__POINTW1FN _0x0,46
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x60
; 0000 0146 put_string(85,6,convert,WHITE,1);
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x61
	RCALL _put_string
; 0000 0147 
; 0000 0148  //////////
; 0000 0149     if(!park)
	SBRC R2,0
	RJMP _0x7C
; 0000 014A     {
; 0000 014B      sprintf(convert,"%d%d.%d",(mrr/100)%10,(mrr/10)%10,mrr%10);
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x67
	RCALL SUBOPT_0x68
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x68
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x68
	RCALL SUBOPT_0x58
; 0000 014C      put_string(3,65,convert,YELLOW,3);
	LDI  R30,LOW(65)
	RCALL SUBOPT_0x59
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x69
; 0000 014D      put_string(105,87,"/100",WHITE,1);
	__POINTW1MN _0x79,17
	RCALL SUBOPT_0x50
	RCALL _put_string
; 0000 014E 
; 0000 014F      }
; 0000 0150     else    //XX
	RJMP _0x7D
_0x7C:
; 0000 0151     {
; 0000 0152      sprintf(convert,"%d%d.%d",(rx/100)%10,(rx/10)%10,rx%10);
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x67
	RCALL SUBOPT_0x6A
	RCALL SUBOPT_0x6B
	RCALL SUBOPT_0x6C
; 0000 0153      put_string(3,65,convert,YELLOW,3);
	RCALL SUBOPT_0x4E
	LDI  R30,LOW(65)
	RCALL SUBOPT_0x59
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x69
; 0000 0154      put_string(105,87,"/",WHITE,1);
	__POINTW1MN _0x79,23
	RCALL SUBOPT_0x50
	RCALL _put_string
; 0000 0155 
; 0000 0156      };
_0x7D:
; 0000 0157 
; 0000 0158   // 
; 0000 0159    sprintf(convert,"%d%d%d.%d ",(dat1/1000)%10,(dat1/100)%10,(dat1/10)%10,dat1%10);
	RCALL SUBOPT_0x64
	__POINTW1FN _0x0,73
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x6D
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x5F
	LDI  R24,16
	RCALL _sprintf
	ADIW R28,20
; 0000 015A    put_string(3,115,convert,WHITE,1);
	RCALL SUBOPT_0x4E
	LDI  R30,LOW(115)
	RCALL SUBOPT_0x61
	RCALL SUBOPT_0x54
; 0000 015B 
; 0000 015C 
; 0000 015D    sprintf(convert,"%d%d%d%d%d%d ",(dat6/1000000)%10,(dat6/100000)%10,(dat6/10000)%10,(dat6/1000)%10,(dat6/100)%10,(dat6/10)%10);
	__POINTW1FN _0x0,86
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x6D
	RCALL SUBOPT_0x5F
	LDI  R24,24
	RCALL _sprintf
	ADIW R28,28
; 0000 015E    put_string(85,115,convert,WHITE,1);// }
	LDI  R30,LOW(85)
	ST   -Y,R30
	LDI  R30,LOW(115)
	RCALL SUBOPT_0x61
	RCALL _put_string
; 0000 015F 
; 0000 0160 ///////////////////////////////////////////////////////////////////////////////////
; 0000 0161 // 
; 0000 0162 if (KEY2==0){
	SBIC 0x10,6
	RJMP _0x7E
; 0000 0163 dat1= 0;
	RCALL SUBOPT_0x3C
; 0000 0164 dat2= 0;
	LDI  R30,LOW(0)
	STS  _dat2,R30
	STS  _dat2+1,R30
	STS  _dat2+2,R30
	STS  _dat2+3,R30
; 0000 0165 dat3= 0;
	STS  _dat3,R30
	STS  _dat3+1,R30
	STS  _dat3+2,R30
	STS  _dat3+3,R30
; 0000 0166 resu=0;
	RCALL SUBOPT_0x62
; 0000 0167 im1=0;}
	RCALL SUBOPT_0x24
; 0000 0168 //=============================
; 0000 0169  if (KEY3 == 0) {
_0x7E:
	SBIC 0x10,7
	RJMP _0x7F
; 0000 016A             first_draw = 1;
	SET
	BLD  R2,1
; 0000 016B             fill_screen(bgcolor);
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x6F
; 0000 016C             mode=a;
; 0000 016D             }
; 0000 016E //=============================
; 0000 016F };
_0x7F:
_0x76:
; 0000 0170 n1++;
	LDI  R26,LOW(_n1)
	LDI  R27,HIGH(_n1)
	RCALL SUBOPT_0x2F
; 0000 0171 if(n1>=250) {n1=0; }; //210
	RCALL SUBOPT_0x70
	CPI  R26,LOW(0xFA)
	LDI  R30,HIGH(0xFA)
	CPC  R27,R30
	BRSH PC+2
	RJMP _0x80
	RCALL SUBOPT_0x71
_0x80:
; 0000 0172 //=======================================  ======================
; 0000 0173              switch (mode) {                               //   
	RCALL SUBOPT_0x42
; 0000 0174              case a:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x83
; 0000 0175              put_string(10,35,"",YELLOW,1);
	RCALL SUBOPT_0x72
	__POINTW1MN _0x79,29
	RCALL SUBOPT_0x73
	RCALL _put_string
; 0000 0176              if (KEY2 == 0) {mode=FORS;};
	SBIC 0x10,6
	RJMP _0x85
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x74
_0x85:
; 0000 0177              if (KEY3 == 0) {delay_ms(250);mode=b;};
	SBIC 0x10,7
	RJMP _0x86
	RCALL SUBOPT_0x75
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x74
_0x86:
; 0000 0178              };
_0x83:
; 0000 0179 
; 0000 017A              switch (mode) {                               //   
	RCALL SUBOPT_0x42
; 0000 017B              case b:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x89
; 0000 017C              put_string(10,35,"",YELLOW,1);
	RCALL SUBOPT_0x72
	__POINTW1MN _0x79,34
	RCALL SUBOPT_0x73
	RCALL _put_string
; 0000 017D              if (KEY2 == 0) {mode=voltmode;};
	SBIC 0x10,6
	RJMP _0x8B
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x74
_0x8B:
; 0000 017E              if (KEY3 == 0) {delay_ms(250);mode=c;};
	SBIC 0x10,7
	RJMP _0x8C
	RCALL SUBOPT_0x75
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RCALL SUBOPT_0x74
_0x8C:
; 0000 017F             };
_0x89:
; 0000 0180 
; 0000 0181              switch (mode) {                               //   
	RCALL SUBOPT_0x42
; 0000 0182              case c:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x8F
; 0000 0183              put_string(10,35,"",YELLOW,1);
	RCALL SUBOPT_0x72
	__POINTW1MN _0x79,39
	RCALL SUBOPT_0x73
	RCALL _put_string
; 0000 0184              if (KEY2 == 0) {mode=PROBEG;};
	SBIC 0x10,6
	RJMP _0x91
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0x74
_0x91:
; 0000 0185              if (KEY3 == 0) {delay_ms(250);mode=d;};
	SBIC 0x10,7
	RJMP _0x92
	RCALL SUBOPT_0x75
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x74
_0x92:
; 0000 0186              };
_0x8F:
; 0000 0187 
; 0000 0188              switch (mode) {                               //   
	RCALL SUBOPT_0x42
; 0000 0189              case d:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x95
; 0000 018A              put_string(10,35,"  ",YELLOW,1);
	RCALL SUBOPT_0x72
	__POINTW1MN _0x79,44
	RCALL SUBOPT_0x73
	RCALL _put_string
; 0000 018B              if (KEY2 == 0) {mode=DS;};
	SBIC 0x10,6
	RJMP _0x97
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x74
_0x97:
; 0000 018C              if (KEY3 == 0) {delay_ms(250);mode=e;};
	SBIC 0x10,7
	RJMP _0x98
	RCALL SUBOPT_0x75
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	RCALL SUBOPT_0x74
_0x98:
; 0000 018D              };
_0x95:
; 0000 018E 
; 0000 018F              switch (mode) {                               //   
	RCALL SUBOPT_0x42
; 0000 0190              case e:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x9B
; 0000 0191              put_string(10,35,"",YELLOW,1);
	RCALL SUBOPT_0x72
	__POINTW1MN _0x79,49
	RCALL SUBOPT_0x73
	RCALL _put_string
; 0000 0192              if (KEY2 == 0) {mode=SP;};
	SBIC 0x10,6
	RJMP _0x9D
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RCALL SUBOPT_0x74
_0x9D:
; 0000 0193              if (KEY3 == 0) {delay_ms(250);//mode=a;};
	SBIC 0x10,7
	RJMP _0x9E
	RCALL SUBOPT_0x75
; 0000 0194              first_draw = 1;
	SET
	BLD  R2,1
; 0000 0195              fill_screen(bgcolor);
	RCALL SUBOPT_0x6
	RCALL _fill_screen
; 0000 0196              mode=ROB;};
	RCALL SUBOPT_0x37
_0x9E:
; 0000 0197              };
_0x9B:
; 0000 0198 
; 0000 0199 
; 0000 019A switch (mode) {                               //   
	RCALL SUBOPT_0x42
; 0000 019B case FORS:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xA1
; 0000 019C sprintf(convert,"%d%d%d%d%d",(PrFors/10000)%10,(PrFors/1000)%10,(PrFors/100)%10,(PrFors/10)%10,PrFors%10);
	RCALL SUBOPT_0x64
	__POINTW1FN _0x0,130
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x76
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x76
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x77
	LDI  R24,20
	RCALL _sprintf
	ADIW R28,24
; 0000 019D put_string(60,35,convert,WHITE,1);
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x54
; 0000 019E sprintf(convert,"%d%d.%d",(rx/100)%10,(rx/10)%10,rx%10);
	RCALL SUBOPT_0x67
	RCALL SUBOPT_0x6A
	RCALL SUBOPT_0x6B
	RCALL SUBOPT_0x6C
; 0000 019F put_string(110,35,convert,GREEN,1);
	RCALL SUBOPT_0x79
	RCALL SUBOPT_0x7A
	RCALL _put_string
; 0000 01A0 if (PrFors > 65535){ PrFors = 0;}
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x2E
	BRLO PC+2
	RJMP _0xA3
	LDI  R30,LOW(0)
	STS  _PrFors,R30
	STS  _PrFors+1,R30
; 0000 01A1 if ( KEY2==0){delay_ms(50);
_0xA3:
	SBIC 0x10,6
	RJMP _0xA4
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL SUBOPT_0x31
; 0000 01A2 PrFors=PrFors+1;
	RCALL SUBOPT_0x30
	ADIW R30,1
	RCALL SUBOPT_0x34
; 0000 01A3 n1=0;
	RCALL SUBOPT_0x71
; 0000 01A4 }
; 0000 01A5 if ( KEY3==0){delay_ms(50);
_0xA4:
	SBIC 0x10,7
	RJMP _0xA5
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL SUBOPT_0x31
; 0000 01A6 PrFors=PrFors-1;
	RCALL SUBOPT_0x30
	SBIW R30,1
	RCALL SUBOPT_0x34
; 0000 01A7 n1=0;
	RCALL SUBOPT_0x71
; 0000 01A8 }
; 0000 01A9 if (n1>240)
_0xA5:
	RCALL SUBOPT_0x7B
	BRSH PC+2
	RJMP _0xA6
; 0000 01AA {if (PrFors!=eepromPrFors) eepromPrFors=PrFors;fill_screen(bgcolor);
	LDI  R26,LOW(_eepromPrFors)
	LDI  R27,HIGH(_eepromPrFors)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x2E
	BRNE PC+2
	RJMP _0xA7
	RCALL SUBOPT_0x30
	LDI  R26,LOW(_eepromPrFors)
	LDI  R27,HIGH(_eepromPrFors)
	RCALL __EEPROMWRW
_0xA7:
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x6F
; 0000 01AB mode=a;}
; 0000 01AC };
_0xA6:
_0xA1:
; 0000 01AD 
; 0000 01AE 
; 0000 01AF // =====================================
; 0000 01B0  switch (mode) {                                  //   
	RCALL SUBOPT_0x42
; 0000 01B1  case voltmode:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xAA
; 0000 01B2 
; 0000 01B3            sprintf(convert,"%d%d%d",(voltag/100)%10,(voltag/10)%10,voltag%10);
	RCALL SUBOPT_0x64
	__POINTW1FN _0x0,26
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x6D
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x5F
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
; 0000 01B4            put_string(60,35,convert,WHITE,1);
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x54
; 0000 01B5            sprintf(convert,"%d%d.%d",(volt/100)%10,(volt/10)%10,volt%10);
	__POINTW1FN _0x0,59
	RCALL SUBOPT_0x52
; 0000 01B6            put_string(110,35,convert,GREEN,1);
	RCALL SUBOPT_0x79
	RCALL SUBOPT_0x7A
	RCALL _put_string
; 0000 01B7               if (voltag>=200) {voltag=0;}
	RCALL SUBOPT_0x7C
	__CPD2N 0xC8
	BRSH PC+2
	RJMP _0xAC
	LDI  R30,LOW(0)
	STS  _voltag,R30
	STS  _voltag+1,R30
	STS  _voltag+2,R30
	STS  _voltag+3,R30
; 0000 01B8               if(KEY2==0){ delay_ms(150);
_0xAC:
	SBIC 0x10,6
	RJMP _0xAD
	RCALL SUBOPT_0x7D
; 0000 01B9               voltag=voltag+1; //    
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x35
; 0000 01BA               n1=0;
	RCALL SUBOPT_0x71
; 0000 01BB               }
; 0000 01BC               if(KEY3==0){ delay_ms(150);
_0xAD:
	SBIC 0x10,7
	RJMP _0xAE
	RCALL SUBOPT_0x7D
; 0000 01BD               voltag=voltag-1; //    
	RCALL SUBOPT_0x40
	__SUBD1N 1
	RCALL SUBOPT_0x35
; 0000 01BE               n1=0;
	RCALL SUBOPT_0x71
; 0000 01BF               }
; 0000 01C0  //=============================
; 0000 01C1               if (n1>240)
_0xAE:
	RCALL SUBOPT_0x7B
	BRSH PC+2
	RJMP _0xAF
; 0000 01C2               {
; 0000 01C3               if (voltag!=eepromvolt)eepromvolt=voltag;
	LDI  R26,LOW(_eepromvolt)
	LDI  R27,HIGH(_eepromvolt)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x32
	RCALL __CPD12
	BRNE PC+2
	RJMP _0xB0
	LDS  R30,_voltag
	LDS  R31,_voltag+1
	LDI  R26,LOW(_eepromvolt)
	LDI  R27,HIGH(_eepromvolt)
	RCALL __EEPROMWRW
; 0000 01C4               fill_screen(bgcolor);
_0xB0:
	RCALL SUBOPT_0x6
	RCALL _fill_screen
; 0000 01C5               mode=b;
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x74
; 0000 01C6               }};
_0xAF:
_0xAA:
; 0000 01C7 //=======================================
; 0000 01C8            switch (mode) {                                  //   
	RCALL SUBOPT_0x42
; 0000 01C9            case PROBEG:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xB3
; 0000 01CA            sprintf(convert,"%d%d%d%d%d%d",(dat6/1000000)%10,(dat6/100000)%10,(dat6/10000)%10,(dat6/1000)%10,(dat6/100)%10,(dat6/10)%10);
	RCALL SUBOPT_0x64
	__POINTW1FN _0x0,141
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x6D
	RCALL SUBOPT_0x5F
	LDI  R24,24
	RCALL _sprintf
	ADIW R28,28
; 0000 01CB            put_string(60,35,convert,WHITE,1);
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x78
	RCALL _put_string
; 0000 01CC 
; 0000 01CD            if(KEY2==0)  //    
	SBIC 0x10,6
	RJMP _0xB5
; 0000 01CE            {
; 0000 01CF                dat6=dat6+10; //     
	RCALL SUBOPT_0x28
	__ADDD1N 10
	RCALL SUBOPT_0x29
; 0000 01D0            n1=0;
	RCALL SUBOPT_0x71
; 0000 01D1            }
; 0000 01D2 
; 0000 01D3            if(KEY3==0)   //    
_0xB5:
	SBIC 0x10,7
	RJMP _0xB6
; 0000 01D4            {
; 0000 01D5            dat6=dat6-10; //     
	RCALL SUBOPT_0x28
	__SUBD1N 10
	RCALL SUBOPT_0x29
; 0000 01D6            n1=0;
	RCALL SUBOPT_0x71
; 0000 01D7            }
; 0000 01D8             //=============================
; 0000 01D9           if (n1>240) {
_0xB6:
	RCALL SUBOPT_0x7B
	BRSH PC+2
	RJMP _0xB7
; 0000 01DA           if (dat6!=data6) data6=dat6;
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x3A
	RCALL __CPD12
	BRNE PC+2
	RJMP _0xB8
	RCALL SUBOPT_0x3B
; 0000 01DB           fill_screen(bgcolor);
_0xB8:
	RCALL SUBOPT_0x6
	RCALL _fill_screen
; 0000 01DC           mode=c;}
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RCALL SUBOPT_0x74
; 0000 01DD //=============================
; 0000 01DE };
_0xB7:
_0xB3:
; 0000 01DF 
; 0000 01E0 // =====================================
; 0000 01E1  switch (mode) {                                  //   
	RCALL SUBOPT_0x42
; 0000 01E2 case DS:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xBB
; 0000 01E3 
; 0000 01E4         sprintf(convert,"%d%d%d%d",(ds/1000)%10,(ds/100)%10,(ds/10)%10,ds%10);
	RCALL SUBOPT_0x64
	__POINTW1FN _0x0,132
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x7E
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x7E
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x7E
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x7E
	RCALL SUBOPT_0x77
	LDI  R24,16
	RCALL _sprintf
	ADIW R28,20
; 0000 01E5         put_string(60,35,convert,WHITE,1);
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x78
	RCALL _put_string
; 0000 01E6 
; 0000 01E7         if (ds > 3000){ ds = 0;}
	RCALL SUBOPT_0x7E
	CPI  R26,LOW(0xBB9)
	LDI  R30,HIGH(0xBB9)
	CPC  R27,R30
	BRSH PC+2
	RJMP _0xBD
	LDI  R30,LOW(0)
	STS  _ds,R30
	STS  _ds+1,R30
; 0000 01E8        // if (ds < 100){ ds = 100;}
; 0000 01E9         if(KEY2==0)  //    
_0xBD:
	SBIC 0x10,6
	RJMP _0xBE
; 0000 01EA         {
; 0000 01EB         delay_ms(150);
	RCALL SUBOPT_0x7D
; 0000 01EC         ds = ds + 1;n1=0;}
	RCALL SUBOPT_0x22
	ADIW R30,1
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x71
; 0000 01ED         if(KEY3==0)   //    
_0xBE:
	SBIC 0x10,7
	RJMP _0xBF
; 0000 01EE         {delay_ms(150);ds=ds-1;n1=0;}
	RCALL SUBOPT_0x7D
	RCALL SUBOPT_0x22
	SBIW R30,1
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x71
; 0000 01EF         //=============================
; 0000 01F0         if (n1>240) {
_0xBF:
	RCALL SUBOPT_0x7B
	BRSH PC+2
	RJMP _0xC0
; 0000 01F1         if (ds!=eepromDS) eepromDS=ds;
	LDI  R26,LOW(_eepromDS)
	LDI  R27,HIGH(_eepromDS)
	RCALL __EEPROMRDW
	RCALL SUBOPT_0x7E
	RCALL SUBOPT_0x2E
	BRNE PC+2
	RJMP _0xC1
	RCALL SUBOPT_0x22
	LDI  R26,LOW(_eepromDS)
	LDI  R27,HIGH(_eepromDS)
	RCALL __EEPROMWRW
; 0000 01F2         fill_screen(bgcolor);
_0xC1:
	RCALL SUBOPT_0x6
	RCALL _fill_screen
; 0000 01F3         mode=d;}
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x74
; 0000 01F4         }
_0xC0:
_0xBB:
; 0000 01F5 
; 0000 01F6          //=======================================
; 0000 01F7  switch (mode) {                                  //      !!!
	RCALL SUBOPT_0x42
; 0000 01F8 case SP:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0xC4
; 0000 01F9             if (MOD == 2)  put_string(80,35,"",WHITE,1);
	LDI  R30,LOW(2)
	CP   R30,R9
	BREQ PC+2
	RJMP _0xC6
	RCALL SUBOPT_0x4C
	LDI  R30,LOW(35)
	ST   -Y,R30
	__POINTW1MN _0x79,57
	RCALL SUBOPT_0x50
	RCALL _put_string
; 0000 01FA            if (MOD == 1)  put_string(80,35,"   ",WHITE,1);
_0xC6:
	LDI  R30,LOW(1)
	CP   R30,R9
	BREQ PC+2
	RJMP _0xC7
	RCALL SUBOPT_0x4C
	LDI  R30,LOW(35)
	ST   -Y,R30
	__POINTW1MN _0x79,66
	RCALL SUBOPT_0x50
	RCALL _put_string
; 0000 01FB            if (KEY2==0)  //    
_0xC7:
	SBIC 0x10,6
	RJMP _0xC8
; 0000 01FC             {
; 0000 01FD             MOD=MOD+1;
	INC  R9
; 0000 01FE             n1=0;
	RCALL SUBOPT_0x71
; 0000 01FF             if (MOD > 2){ MOD = 1;};
	LDI  R30,LOW(2)
	CP   R30,R9
	BRLO PC+2
	RJMP _0xC9
	LDI  R30,LOW(1)
	MOV  R9,R30
_0xC9:
; 0000 0200             eeMOD = MOD;
	MOV  R30,R9
	LDI  R26,LOW(_eeMOD)
	LDI  R27,HIGH(_eeMOD)
	RCALL __EEPROMWRB
; 0000 0201             while (KEY2==0)delay_ms(30);};
_0xCA:
	SBIC 0x10,6
	RJMP _0xCC
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RCALL SUBOPT_0x31
	RJMP _0xCA
_0xCC:
_0xC8:
; 0000 0202             //=============================
; 0000 0203            if (n1>240) {
	RCALL SUBOPT_0x7B
	BRSH PC+2
	RJMP _0xCD
; 0000 0204            fill_screen(bgcolor);
	RCALL SUBOPT_0x6
	RCALL _fill_screen
; 0000 0205            mode=e;}
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	RCALL SUBOPT_0x74
; 0000 0206            };
_0xCD:
_0xC4:
; 0000 0207 //====================================================================
; 0000 0208 }}
	RJMP _0x68
_0x6A:
_0xCE:
	RJMP _0xCE

	.DSEG
_0x79:
	.BYTE 0x4B
;
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x7F
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BRNE PC+2
	RJMP _0x2000010
	RCALL SUBOPT_0x7F
	RCALL SUBOPT_0x80
	MOVW R16,R30
	SBIW R30,0
	BREQ PC+2
	RJMP _0x2000011
	RJMP _0x2000012
_0x2000011:
	__CPWRN 16,17,2
	BRSH PC+2
	RJMP _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	RCALL SUBOPT_0x7F
	ADIW R26,2
	RCALL SUBOPT_0x2F
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	RCALL SUBOPT_0x7F
	RCALL __GETW1P
	TST  R31
	BRPL PC+2
	RJMP _0x2000014
	RCALL SUBOPT_0x7F
	RCALL SUBOPT_0x2F
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	RCALL SUBOPT_0x7F
	RCALL SUBOPT_0x1A
	ST   X+,R30
	ST   X,R31
_0x2000015:
	RCALL __LOADLOCR2
	ADIW R28,5
	RET
__print_G100:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BREQ PC+2
	RJMP _0x200001C
	CPI  R18,37
	BREQ PC+2
	RJMP _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	RCALL SUBOPT_0x81
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x200001F
	CPI  R18,37
	BREQ PC+2
	RJMP _0x2000020
	RCALL SUBOPT_0x81
	LDI  R17,LOW(0)
	RJMP _0x200001B
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BREQ PC+2
	RJMP _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BREQ PC+2
	RJMP _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BREQ PC+2
	RJMP _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BREQ PC+2
	RJMP _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRSH PC+2
	RJMP _0x200002A
	CPI  R18,58
	BRLO PC+2
	RJMP _0x200002A
	RJMP _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BREQ PC+2
	RJMP _0x200002F
	RCALL SUBOPT_0x82
	RCALL SUBOPT_0x83
	RCALL SUBOPT_0x82
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0x84
	RJMP _0x2000030
	RJMP _0x2000031
_0x200002F:
	CPI  R30,LOW(0x73)
	BREQ PC+2
	RJMP _0x2000032
_0x2000031:
	RCALL SUBOPT_0x85
	RCALL SUBOPT_0x86
	RCALL SUBOPT_0x87
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
	RJMP _0x2000034
_0x2000032:
	CPI  R30,LOW(0x70)
	BREQ PC+2
	RJMP _0x2000035
_0x2000034:
	RCALL SUBOPT_0x85
	RCALL SUBOPT_0x86
	RCALL SUBOPT_0x87
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
	RJMP _0x2000037
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ PC+2
	RJMP _0x2000038
_0x2000037:
	RJMP _0x2000039
_0x2000038:
	CPI  R30,LOW(0x69)
	BREQ PC+2
	RJMP _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BREQ PC+2
	RJMP _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	RCALL SUBOPT_0x88
	LDI  R17,LOW(5)
	RJMP _0x200003D
	RJMP _0x200003E
_0x200003C:
	CPI  R30,LOW(0x58)
	BREQ PC+2
	RJMP _0x200003F
_0x200003E:
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	RCALL SUBOPT_0x88
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	RCALL SUBOPT_0x85
	RCALL SUBOPT_0x86
	RCALL SUBOPT_0x89
	LDD  R26,Y+11
	TST  R26
	BRMI PC+2
	RJMP _0x2000043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x89
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BRNE PC+2
	RJMP _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	RCALL SUBOPT_0x85
	RCALL SUBOPT_0x86
	RCALL SUBOPT_0x89
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRLO PC+2
	RJMP _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	RCALL SUBOPT_0x81
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BRNE PC+2
	RJMP _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	RCALL SUBOPT_0x88
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	RCALL SUBOPT_0x81
	CPI  R21,0
	BRNE PC+2
	RJMP _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x88
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	RCALL SUBOPT_0x15
	BRSH PC+2
	RJMP _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x89
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRSH PC+2
	RJMP _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRS R16,4
	RJMP _0x2000060
	RJMP _0x2000061
_0x2000060:
	CPI  R18,49
	BRLO PC+2
	RJMP _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE PC+2
	RJMP _0x2000063
	RJMP _0x2000062
_0x2000063:
	ORI  R16,LOW(16)
	RJMP _0x2000065
_0x2000062:
	CP   R21,R19
	BRSH PC+2
	RJMP _0x2000067
	SBRC R16,0
	RJMP _0x2000067
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
	ORI  R16,LOW(16)
_0x2000065:
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x84
	CPI  R21,0
	BRNE PC+2
	RJMP _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	RCALL SUBOPT_0x81
	CPI  R21,0
	BRNE PC+2
	RJMP _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
_0x2000057:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRSH PC+2
	RJMP _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BRNE PC+2
	RJMP _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x84
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
	LDI  R17,LOW(0)
_0x200002E:
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x8A
	SBIW R30,0
	BREQ PC+2
	RJMP _0x2000072
	RCALL SUBOPT_0x1A
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	RCALL SUBOPT_0x8A
	RCALL SUBOPT_0x88
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x14
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	RCALL SUBOPT_0x14
	MOVW R30,R28
	ADIW R30,10
	RCALL SUBOPT_0x14
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG

	.ESEG
_data1:
	.DW  0x0
_data6:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
_data2:
	.DB  LOW(0x102),HIGH(0x102),BYTE3(0x102),BYTE4(0x102)
_eepromPrFors:
	.DW  0xF99C
_eepromvolt:
	.DW  0x7A
_eepromDS:
	.DW  0x2A3
_eeim1:
	.DW  0x0
_eeMOD:
	.DB  0x2

	.DSEG
_trx:
	.BYTE 0x1
_speed:
	.BYTE 0x2
_mrr:
	.BYTE 0x2
_speedP:
	.BYTE 0x2
_ds:
	.BYTE 0x2
_dsl:
	.BYTE 0x2
_n1:
	.BYTE 0x2
_bgcolor:
	.BYTE 0x2
_PrFors:
	.BYTE 0x2
_voltag:
	.BYTE 0x4
_dat1:
	.BYTE 0x4
_dat2:
	.BYTE 0x4
_dat3:
	.BYTE 0x4
_dat6:
	.BYTE 0x4
_volt:
	.BYTE 0x4
_im1:
	.BYTE 0x2
_resu:
	.BYTE 0x4
_n:
	.BYTE 0x2
_convert:
	.BYTE 0x20
_mode:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	SBI  0x18,5
	CBI  0x18,5
	LDI  R30,LOW(80)
	OUT  0xD,R30
	LD   R30,Y
	OUT  0xF,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	OUT  0xD,R30
	SBI  0x18,2
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	RJMP _lcd_write_dat

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 27 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5:
	ST   -Y,R30
	RJMP _lcd_write_cmd

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:53 WORDS
SUBOPT_0x6:
	LDS  R30,_bgcolor
	LDS  R31,_bgcolor+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_write16

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_write16

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	LDD  R30,Y+1
	LDI  R31,0
	ADIW R30,2
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	LD   R30,Y
	LDI  R31,0
	ADIW R30,1
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xB:
	LDD  R30,Y+11
	LDI  R31,0
	ADIW R30,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC:
	MUL  R30,R26
	MOVW R30,R0
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	SBIW R26,1
	ST   -Y,R27
	ST   -Y,R26
	RJMP _lcd_write16

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD:
	LDD  R30,Y+10
	LDI  R31,0
	ADIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xE:
	MOV  R30,R17
	LDI  R31,0
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDD  R30,Y+9
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	RCALL __MULW12U
	SUBI R30,LOW(-_ascii_tab_G000*2)
	SBCI R31,HIGH(-_ascii_tab_G000*2)
	MOVW R22,R30
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	ADD  R30,R22
	ADC  R31,R23
	LPM  R16,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x12:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x13:
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 126 TIMES, CODE SIZE REDUCTION:123 WORDS
SUBOPT_0x14:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x15:
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	LDI  R31,0
	SUB  R26,R30
	SBC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	LDD  R26,Y+19
	LDD  R27,Y+19+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x18:
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	RCALL SUBOPT_0x14
	RJMP _LCD_Pixel

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1B:
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1C:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	__ADDWRR 16,17,30,31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	__ADDWRR 18,19,30,31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1F:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	LDS  R30,_im1
	LDS  R31,_im1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x21:
	STS  _im1,R30
	STS  _im1+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x22:
	LDS  R30,_ds
	LDS  R31,_ds+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	LDS  R26,_im1
	LDS  R27,_im1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x24:
	LDI  R30,LOW(0)
	STS  _im1,R30
	STS  _im1+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x25:
	LDS  R30,_dat1
	LDS  R31,_dat1+1
	LDS  R22,_dat1+2
	LDS  R23,_dat1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x26:
	__ADDD1N 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x27:
	STS  _dat1,R30
	STS  _dat1+1,R31
	STS  _dat1+2,R22
	STS  _dat1+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x28:
	LDS  R30,_dat6
	LDS  R31,_dat6+1
	LDS  R22,_dat6+2
	LDS  R23,_dat6+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x29:
	STS  _dat6,R30
	STS  _dat6+1,R31
	STS  _dat6+2,R22
	STS  _dat6+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2A:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2B:
	LDS  R26,_speed
	LDS  R27,_speed+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2C:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 32 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x2D:
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2E:
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2F:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x30:
	LDS  R30,_PrFors
	LDS  R31,_PrFors+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x31:
	RCALL SUBOPT_0x14
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x32:
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x33:
	LDI  R26,LOW(_data6)
	LDI  R27,HIGH(_data6)
	RCALL __EEPROMRDD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x34:
	STS  _PrFors,R30
	STS  _PrFors+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x35:
	STS  _voltag,R30
	STS  _voltag+1,R31
	STS  _voltag+2,R22
	STS  _voltag+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x36:
	STS  _ds,R30
	STS  _ds+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x37:
	RCALL SUBOPT_0x19
	STS  _mode,R30
	STS  _mode+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:40 WORDS
SUBOPT_0x38:
	LDS  R26,_dat1
	LDS  R27,_dat1+1
	LDS  R24,_dat1+2
	LDS  R25,_dat1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x39:
	LDS  R26,_dat2
	LDS  R27,_dat2+1
	LDS  R24,_dat2+2
	LDS  R25,_dat2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:96 WORDS
SUBOPT_0x3A:
	LDS  R26,_dat6
	LDS  R27,_dat6+1
	LDS  R24,_dat6+2
	LDS  R25,_dat6+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3B:
	RCALL SUBOPT_0x28
	LDI  R26,LOW(_data6)
	LDI  R27,HIGH(_data6)
	RCALL __EEPROMWRD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3C:
	LDI  R30,LOW(0)
	STS  _dat1,R30
	STS  _dat1+1,R30
	STS  _dat1+2,R30
	STS  _dat1+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x3D:
	__GETD1N 0x3E8
	RCALL __DIVD21U
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3E:
	RCALL __CWD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3F:
	STS  _volt,R30
	STS  _volt+1,R31
	STS  _volt+2,R22
	STS  _volt+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x40:
	LDS  R30,_voltag
	LDS  R31,_voltag+1
	LDS  R22,_voltag+2
	LDS  R23,_voltag+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x41:
	__GETD1N 0xF4240
	RCALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x42:
	LDS  R30,_mode
	LDS  R31,_mode+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x43:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x44:
	LDI  R30,LOW(21)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x45:
	LDI  R30,LOW(60)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x46:
	LDI  R30,LOW(33280)
	LDI  R31,HIGH(33280)
	RCALL SUBOPT_0x14
	RCALL _lcd_line
	RJMP SUBOPT_0x43

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x47:
	LDI  R30,LOW(20)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x48:
	LDI  R30,LOW(55)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x49:
	LDI  R30,LOW(160)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4A:
	ST   -Y,R30
	RJMP SUBOPT_0x49

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4B:
	ST   -Y,R30
	LDI  R30,LOW(33280)
	LDI  R31,HIGH(33280)
	RCALL SUBOPT_0x14
	RCALL _lcd_line
	LDI  R30,LOW(100)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4C:
	LDI  R30,LOW(80)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4D:
	LDI  R30,LOW(33280)
	LDI  R31,HIGH(33280)
	RCALL SUBOPT_0x14
	RJMP _lcd_line

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4E:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4F:
	RCALL SUBOPT_0x14
	LDI  R30,LOW(63488)
	LDI  R31,HIGH(63488)
	RCALL SUBOPT_0x14
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:40 WORDS
SUBOPT_0x50:
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x14
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x51:
	LDI  R30,LOW(_convert)
	LDI  R31,HIGH(_convert)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:55 WORDS
SUBOPT_0x52:
	RCALL SUBOPT_0x14
	LDS  R26,_volt
	LDS  R27,_volt+1
	LDS  R24,_volt+2
	LDS  R25,_volt+3
	__GETD1N 0x64
	RCALL __DIVD21U
	RCALL SUBOPT_0x2D
	__GETD1N 0xA
	RCALL __MODD21U
	RCALL __PUTPARD1
	LDS  R26,_volt
	LDS  R27,_volt+1
	LDS  R24,_volt+2
	LDS  R25,_volt+3
	__GETD1N 0xA
	RCALL __DIVD21U
	RCALL SUBOPT_0x2D
	__GETD1N 0xA
	RCALL __MODD21U
	RCALL __PUTPARD1
	LDS  R26,_volt
	LDS  R27,_volt+1
	LDS  R24,_volt+2
	LDS  R25,_volt+3
	__GETD1N 0xA
	RCALL __MODD21U
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x53:
	RCALL SUBOPT_0x51
	RJMP SUBOPT_0x50

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x54:
	RCALL _put_string
	RCALL SUBOPT_0x51
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x55:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	RCALL SUBOPT_0x32
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x56:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x57:
	RCALL __DIVW21U
	MOVW R26,R30
	RCALL SUBOPT_0x56
	RCALL __MODW21U
	RCALL SUBOPT_0x32
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x58:
	RCALL SUBOPT_0x56
	RCALL __MODW21U
	RCALL SUBOPT_0x32
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x4E

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x59:
	ST   -Y,R30
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x14
	LDI  R30,LOW(65504)
	LDI  R31,HIGH(65504)
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x5A:
	LDS  R26,_dat3
	LDS  R27,_dat3+1
	LDS  R24,_dat3+2
	LDS  R25,_dat3+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5B:
	__GETD1N 0xA
	RCALL __MODD21U
	RCALL __PUTPARD1
	RJMP SUBOPT_0x5A

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x5C:
	__GETD1N 0x64
	RCALL __DIVD21U
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 29 TIMES, CODE SIZE REDUCTION:82 WORDS
SUBOPT_0x5D:
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5E:
	RCALL __DIVD21U
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:44 WORDS
SUBOPT_0x5F:
	RCALL SUBOPT_0x5D
	RCALL __MODD21U
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x60:
	LDI  R24,16
	RCALL _sprintf
	ADIW R28,20
	LDI  R30,LOW(85)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x61:
	ST   -Y,R30
	RJMP SUBOPT_0x53

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x62:
	LDI  R30,LOW(0)
	STS  _resu,R30
	STS  _resu+1,R30
	STS  _resu+2,R30
	STS  _resu+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x63:
	__GETD2N 0x64
	RCALL __MULD12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x64:
	RCALL SUBOPT_0x51
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x65:
	LDS  R26,_resu
	LDS  R27,_resu+1
	LDS  R24,_resu+2
	LDS  R25,_resu+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x66:
	__GETD1N 0x2710
	RJMP SUBOPT_0x5E

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x67:
	__POINTW1FN _0x0,59
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x68:
	LDS  R26,_mrr
	LDS  R27,_mrr+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x69:
	RCALL _put_string
	LDI  R30,LOW(105)
	ST   -Y,R30
	LDI  R30,LOW(87)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6A:
	MOV  R26,R5
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x6B:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21
	MOVW R26,R30
	RCALL SUBOPT_0x56
	RCALL __MODW21
	RCALL SUBOPT_0x3E
	RCALL __PUTPARD1
	RJMP SUBOPT_0x6A

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x6C:
	RCALL SUBOPT_0x56
	RCALL __DIVW21
	MOVW R26,R30
	RCALL SUBOPT_0x56
	RCALL __MODW21
	RCALL SUBOPT_0x3E
	RCALL __PUTPARD1
	MOV  R26,R5
	CLR  R27
	RCALL SUBOPT_0x56
	RCALL __MODW21
	RCALL SUBOPT_0x3E
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6D:
	RCALL SUBOPT_0x5D
	RJMP SUBOPT_0x5E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6E:
	RCALL SUBOPT_0x3A
	__GETD1N 0x186A0
	RJMP SUBOPT_0x5E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6F:
	RCALL _fill_screen
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	STS  _mode,R30
	STS  _mode+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x70:
	LDS  R26,_n1
	LDS  R27,_n1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x71:
	LDI  R30,LOW(0)
	STS  _n1,R30
	STS  _n1+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x72:
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x73:
	RCALL SUBOPT_0x14
	LDI  R30,LOW(65504)
	LDI  R31,HIGH(65504)
	RCALL SUBOPT_0x14
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x74:
	STS  _mode,R30
	STS  _mode+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x75:
	LDI  R30,LOW(250)
	LDI  R31,HIGH(250)
	RJMP SUBOPT_0x31

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x76:
	LDS  R26,_PrFors
	LDS  R27,_PrFors+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x77:
	RCALL SUBOPT_0x56
	RCALL __MODW21U
	RCALL SUBOPT_0x32
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x78:
	LDI  R30,LOW(35)
	RJMP SUBOPT_0x61

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x79:
	LDI  R30,LOW(110)
	ST   -Y,R30
	LDI  R30,LOW(35)
	ST   -Y,R30
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7A:
	LDI  R30,LOW(2016)
	LDI  R31,HIGH(2016)
	RCALL SUBOPT_0x14
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7B:
	RCALL SUBOPT_0x70
	CPI  R26,LOW(0xF1)
	LDI  R30,HIGH(0xF1)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x7C:
	LDS  R26,_voltag
	LDS  R27,_voltag+1
	LDS  R24,_voltag+2
	LDS  R25,_voltag+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7D:
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	RJMP SUBOPT_0x31

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7E:
	LDS  R26,_ds
	LDS  R27,_ds+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7F:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x80:
	ADIW R26,4
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x81:
	ST   -Y,R18
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x1B
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x82:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x83:
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x84:
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x1B
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x85:
	RCALL SUBOPT_0x82
	RJMP SUBOPT_0x83

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x86:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	RJMP SUBOPT_0x80

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x87:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x88:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x89:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8A:
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOVW R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRD:
	RCALL __EEPROMWRW
	ADIW R26,2
	MOVW R0,R30
	MOVW R30,R22
	RCALL __EEPROMWRW
	MOVW R30,R0
	SBIW R26,2
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
